<?php
/* 
	Fonctions de base
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/
/*
Pour fonctions de temps (respect du standard strict)
$timezone doit etre dfini dans _parametres.inc.php
*/
//include 'parametres/_parametres.inc.php';
if (version_compare(phpversion(),"5.1.0",'>=')) date_default_timezone_set($timezone);

define('URL_FORMAT',
'/^(https?):\/\/'.                                         // protocol
'(([a-z0-9$_\.\+!\*\'\(\),;\?&=-]|%[0-9a-f]{2})+'.         // username
'(:([a-z0-9$_\.\+!\*\'\(\),;\?&=-]|%[0-9a-f]{2})+)?'.      // password
'@)?(?#'.                                                  // auth requires @
')((([a-z0-9]\.|[a-z0-9][a-z0-9-]*[a-z0-9]\.)*'.                      // domain segments AND
'[a-z][a-z0-9-]*[a-z0-9]'.                                 // top level domain  OR
'|((\d|[1-9]\d|1\d{2}|2[0-4][0-9]|25[0-5])\.){3}'.
'(\d|[1-9]\d|1\d{2}|2[0-4][0-9]|25[0-5])'.                 // IP address
')(:\d+)?'.                                                // port
')(((\/+([a-z0-9$_\.\+!\*\'\(\),;:@&=-]|%[0-9a-f]{2})*)*'. // path
'(\?([a-z0-9$_\.\+!\*\'\(\),;:@&=-]|%[0-9a-f]{2})*)'.      // query string
'?)?)?'.                                                   // path and query string optional
'(#([a-z0-9$_\.\+!\*\'\(\),;:@&=-]|%[0-9a-f]{2})*)?'.      // fragment
'$/i');

function nettoyerApostrophes($content)
{
	debug($content);
	return str_replace(array("'",'',"`","", "&146;", "&#2019;", "&#8217;", "&apos;", "&amp;apos;","&#039;"), "'", $content);
}
/* ConvertDate 
	Transforme une date sql aaaa-mm-jj en date lisible
*/
function dateSqlEnSaisie($date)           
{
	if ($date==''||$date=='0000-00-00'||$date=='9999-12-31') return '';
	if ($date=='9999-12-30') return 'Tlformation';
	$t=explode("-",$date);
	return "$t[2]/$t[1]/$t[0]";
} 

function facteurDate($j,$m,$a)
{
	if ($m<=2) 
	 	$f=365*$a+$j+31*($m-1)+intval(($a-1)/4)-intval(0.75*intval((($a-1)/100)+1));
	else
		$f=365*$a+$j+31*($m-1)-intval(0.4*$m+2.3)+intval($a/4)-intval(0.75*(intval($a/100)+1));
	return $f;
}
/*
	Renvoie 0= samedi, 1= dimanche, etc...
*/

function jourSemaine($j,$m,$a)
{
	$f=facteurDate($j,$m,$a);
	return $f%7;
}                          
                        
/* dateSQLEnTexte 
	Transforme une date sql aaaa-mm-jj en date texte: lundi 17 janvier 2005
*/
function dateSQLEnTexte($date)
{
	if ($date==''||$date=='0000-00-00'||$date=='9999-12-31') return htmlentities(' dfinir',ENT_COMPAT,'ISO-8859-15');
	if ($date=='9999-12-30') return 'Tlformation';
	$Jours=array("samedi","dimanche","lundi","mardi","mercredi","jeudi","vendredi");
	$Mois=array("-","janvier","fvrier","mars","avril","mai","juin","juillet","aot","septembre","octobre","novembre","dcembre");
	$t1=explode("-",$date);
	$m=intval($t1[1]);
	$j=jourSemaine($t1[2],$t1[1],$t1[0]);
	$s=sprintf("%s %d %s %s",$Jours[$j],$t1[2],htmlentities($Mois[$m],ENT_COMPAT,'ISO-8859-15'),$t1[0]);
	return $s;
} 
//version texte seulement
function dateSQLEnTexteTxt($date)
{
	if ($date==''||$date=='0000-00-00'|$date=='9999-12-31') return " dfinir";
	if ($date=='9999-12-30') return 'Tlformation';
	$Jours=array("samedi","dimanche","lundi","mardi","mercredi","jeudi","vendredi");
	$Mois=array("-","janvier","fvrier","mars","avril","mai","juin","juillet","aot","septembre","octobre","novembre","dcembre");
	$t1=explode("-",$date);
	$m=intval($t1[1]);
	$j=jourSemaine($t1[2],$t1[1],$t1[0]);
	$s=sprintf("%s %d %s %s",$Jours[$j],$t1[2],$Mois[$m],$t1[0]);
	return $s;
} 
/*
	E: 3.50
	S: 3h 30
*/
function reelEnHeure($h)
{
	$dh=doubleval($h);
	$ih=intval($h);
	$s="$ih&nbsp;h";
	if ($dh-$ih>0){
		$v=intval(($dh-$ih)*60);
		if ($v>0) $s.="&nbsp;$v&nbsp;mn";	
	}
	return $s; 	
}
function reelEnHeureTxt($h)
{
	$dh=doubleval($h);
	$ih=intval($h);
	$s="$ih h";
	if ($dh-$ih>0){
		$v=intval(($dh-$ih)*60);
		if ($v>0) $s.=" $v mn";	
	}
	return $s; 	
}
function horaireSqlEnHeure($h, $complet=false)
{
	if ($h=='') return '';
	$t=explode(':',$h);
	if (count($t)<3) return '';
	if(!$complet)
		if ($t[0]==0 && $t[1]==0) return '';
	if($t[1]==0) return sprintf("%dh",$t[0]);	
	else return sprintf("%dh%02d",$t[0],$t[1]);
}
/* HoraireSaisiEnSql
	Si retour chaine vide: erreur
	NB on tolre certaines syntaxes incorrectes pour utiliser cette routine dans l'importation  partir de la v3
	Ex: 8h - 11h est traduit en : 8h)
*/
function horaireSaisiEnSql($s)
{
	$s=trim($s);
	if ($s=='') return '';
	$t=array();
	if (strpos($s,'h')!==false) $t=explode('h',$s);
	else if (strpos($s,':')!==false) $t=explode(':',$s);
	else {
		$i=0;
		while($i<strlen($s) && is_numeric($s[$i]))++$i;
		$t[]=substr($s,0,$i);
	}
	if (count($t)==0) return '';
	$t[0]=trim($t[0]);
	if (!is_numeric($t[0])) return '';
	if ($t[0]<0 || $t[0]>=24) return '';
	if (count($t)==1) return sprintf("%02d:00:00",$t[0]);
	$s=trim($t[1]);
	$i=0;
	while($i<strlen($s) && is_numeric($s[$i]))++$i;
	$t[1]=substr($s,0,$i);
	if ($t[1]==0) return sprintf("%02d:00:00",$t[0]);
	if ($t[1]>=60) return '';
	return sprintf("%02d:%02d:00",$t[0],$t[1]);		

}

/*
	
	Teste et formate la date. Renvoie une valeur comprhensible pour MySQL
	ou une chaine '9999-12-31' si date non dfinie
	ou une chaine vide si erreur
*/
	
function dateSaisieEnSql($date)
{
	if ($date=='') return '9999-12-31';
	$d2=strtolower($date);
	if ($d2=='foad'||$d2=='fod'||$d2=='tlformation'||$d2=='teleformation' ||$d2=='tf') return '9999-12-30';
	$t=explode("/",$date);
	$dateCour=getdate(time());
	if (count($t)==2) {  // jour, mois
		$Annee=$dateCour["year"];
		if ($t[1]<$dateCour["mon"]||($t[1]==$dateCour["mon"]&&$t[0]<$dateCour["mday"]) ) ++$Annee;
		$t[]=$Annee;
	}
	else 
		if (count($t)!=3) return '';
	if (strlen($t[2])==2) $t[2]='20'.$t[2];
	else if (strlen($t[2])==1) $t[2]='200'.$t[2];
	if (!is_numeric($t[1])) return '';
	if (!is_numeric($t[0])) return '';
	if (!is_numeric($t[2])) return '';
	$b=checkdate($t[1],$t[0],$t[2]);	 // mois, jour, anne!!!
	if (!$b) return '';
	if ($t[2]<=2000) return '';
	if (strlen($t[1])==1) $t[1]='0'.$t[1];
	if (strlen($t[0])==1) $t[0]='0'.$t[0];
	return "$t[2]-$t[1]-$t[0]";
}
/*
	DateSub
	Diffrence entre deux timestamp. 'aaaa-mm-jj hh:mm:ss'
	d1-d2
	Renvoie le nombre de secondes.
*/
function dateSub($d1,$d2)
{
	$a1=substr($d1,0,4);
	$m1=substr($d1,5,2);
	$j1=substr($d1,8,2);
	$h1=substr($d1,11,2);
	$n1=substr($d1,14,2);
	$s1=substr($d1,17,2);
	$t1=mktime($h1,$n1,$s1,$m1,$j1,$a1);
	
	$a2=substr($d2,0,4);
	$m2=substr($d2,5,2);
	$j2=substr($d2,8,2);
	$h2=substr($d2,11,2);
	$n2=substr($d2,14,2);
	$s2=substr($d2,17,2);
	$t2=mktime($h2,$n2,$s2,$m2,$j2,$a2);
	
	if ($t1<0 || $t2<0) return 0;
	return $t1-$t2;
}

/* DiffrenceDates
Diffrence entre deux dates au format 'aaaa-mm-jj hh:mm:ss"
retourne la diffrence au mme format 
NB: compatible toutes versions PHP
*/	
function differenceDates($d1,$d2)
{
	$i=dateSub($d1,$d2);
	if ($i<=0) return "&nbsp;";
	$s=$i%60;
	$i-=$s;
	$i/=60;
	$mn=$i%60;
	$i-=$mn;
	$i/=60;
	$h=$i%24;
	$i-=$h;
	$j=$i/24;
	// arrondir  la minute
	if ($s>=30) {
		++$mn;
		if ($mn>=60) {
			++$h;
			$mn-=60;
			if ($h>=24) {
				$h-=24;
				++$j;
			}
		}
	}
	if ($j==0 &&$h==0)  return sprintf("%02dmn",$mn);
	else if ($j==0) return sprintf("%dh %02dmn",$h,$mn);
	else return sprintf("%dj %02dh %02dmn",$j,$h,$mn);
		
}
/*
Ajoute un intervalle rel  une heure au format SQL hh:mm:ss ou hh:mm et produit une nouvelle heure
Intervalle: double, 1= 1h, 1.5= 1h30...
S: nouvelle heure - Attention, il ne faut pas dpasser 24 h sinon l'heure sera ramene  un nombre entre 0 et 23, mais le programma appelant n'a aucune possibilit de modifier la date
*/
function ajouteIntervalle($h,$i)
{
	$mnSupl=round(60*doubleval($i));
	$t=explode(':',$h);
	if (count($t)<2) return $h;
	$m=intval($t[1])+$mnSupl;
	$hSupl=intval($m/60);
	$t[1]=$m%60;
	$t[0]+=$hSupl;
	if ($t[0]>24) $t[0]=$t[0]%24;
	if (count($t)==2) return $t[0].':'.$t[1].':00';
	else return $t[0].':'.$t[1].':'.$t[2];
	
		
}
function exportFichier($file,$nom,$ext="csv")
{
	$d=getdate();
	$j=$d['mday'];
	if ($j<=9) $j='0'.$j;
	$m=$d['mon'];
	if ($m<=9) $m='0'.$m;
	$a=$d['year'];
	$fich="$nom$a-$m-$j.$ext"; 
	header('Content-Transfer-Encoding: none');
	header("Content-Type: application/octetstream; name=\"$fich\"");
	header("Content-Disposition: attachment; filename=\"$fich\"");
	header('Content-length: '.filesize($file));
	@readfile($file);
	@unlink($file);
}

function testRNE($identifiant)
{
	if (strlen($identifiant)!=8) return false;
	for ($i=0;$i<7;++$i) if ($identifiant[$i]<'0' || $identifiant[$i]>'9') return false;
	$c=strtoupper($identifiant[7]);
	return ($c>='A' && $c<='Z');
}

function afficheActualite($msg, $puce=true, $pasDiv=false)
{
	$msg=htmlentities($msg,ENT_COMPAT,'ISO-8859-15');
	if ($msg=='') return;
	if (!$pasDiv) print "<div class=\"alaffiche\">\n";
	$pos=strpos($msg,"\n");
	if ($puce) print "<ul>\n";
	while($pos!==false) {
		afficheActualiteSub(substr($msg,0,$pos),$puce);
		$msg=substr($msg,$pos+1);
		$pos=strpos($msg,"\n");	
	}
	afficheActualiteSub($msg,$puce);
	if($puce) print "</ul>\n";
	if (!$pasDiv) print "</div>\n";
}
function afficheActualiteSub($msg,$puce)
{
	$msg1=str_replace('{{{','<b><em>',$msg);
	$msg1=str_replace('}}}','</em></b>',$msg1);
	$msg1=str_replace('{{','<b>',$msg1);
	$msg1=str_replace('}}','</b>',$msg1);
	$msg1=str_replace('{','<em>',$msg1);
	$msg1=str_replace('}','</em>',$msg1);
	if ($puce) print "<li>$msg1</li>";
	else print $msg1;
}
/*
	TesteEmail
	Teste une adresse e-mail. Renvoie true si OK
*/
function testeEmail( $eMail)
{
	if (strlen($eMail)>0) return preg_match('#^[\w\.-]+@[\w\.-]+\.[a-zA-Z]{2,63}$#',$eMail);
	else return false;
}
function testeEmailAca( $email,$h)
{
	if ($email=='') return false;
	if (!preg_match('#^[\w.-]+@[\w.-]+\.[a-zA-Z]{2,63}$#',$email)) return false;
	$r=query("SELECT suffixe FROM suffixes",$h);
	while ($row=@mysqli_fetch_row($r)) {
		$suf=$row[0];
		$l=strlen($suf);
		if (!$l) continue;
		if (substr($email,-$l)==$suf) return true;
	}
	return false;
}
function testeEmailEcole($courriel,$h) 
{
	$courriel=trim($courriel);
	if ($courriel=='') return false;	
	$suffixe_defaut=suffixeDefaut($h);
	if (!$suffixe_defaut) return false;
	$suffixe_defaut=str_replace('.','\.',$suffixe_defaut);
	$suffixe_defaut=str_replace('-','\-',$suffixe_defaut);
	//return preg_match('#^[0-9]{7}#',$courriel);
	return preg_match('#^(ce\.)?[0-9]{7}[a-z]@'.$suffixe_defaut.'$#',$courriel);
	
}
function suffixeDefaut($h)
{
	return queryValue("SELECT suffixe FROM suffixes ORDER BY defaut DESC, id_suffixe ASC",$h);
}
/*
Intersection Horaires
Renvoie vrai si deux animations se chevauchent
*/
function intersectionHoraires($date1,$horaire1,$duree1,$date2,$horaire2,$duree2)
{
	$d1=$date1.' '.$horaire1;
	$d2=$date2.' '.$horaire2;
	if ($d1>$d2) {
		$d=$d2;
		$d2=$d1;
		$d1=$d;
		$d=$duree1;
		$duree1=$duree2;
		$duree2=$d;
	}	
	// ici d1<d2
	$intervalle=dateSub($d2,$d1);
	$duree=$duree1*3600;// d1 < d2 donc d1 commence avant d2, =>
	return $intervalle<$duree;
}

function tronque($chaine, $longueur)
{
	$l=strlen($chaine);
	if ($longueur<3 || $l<=$longueur || $l<3) return $chaine;
	return htmlentities(substr($chaine, 0, $longueur-3),ENT_COMPAT,'ISO-8859-15').'...';
}
// Certains noms d'cole ont un chiffre romain: II, III, IV, etc. Lorsqu'on les met en majuscules automatiquement, cela devient Ii, Iii, etc.
// Cette fonction remdie au pb pour les nombres de II  XX 
function majusculeChiffresRomains($mot)
{
	$nombres1=array(" Iii"," Ii"," Iv"," Viii"," Vii"," Vi"," Ix"," Xiii"," Xii"," Xi"," Xiv"," Xv"," Xviii"," Xvii"," Xvi"," Xix"," Xx");
	$nombres2=array(" III"," II"," IV"," VIII"," VII"," VI"," IX"," XIII"," XII"," XI"," XIV"," XV"," XVIII"," XVII"," XVI"," XIX"," XX");
	return str_replace($nombres1,$nombres2,$mot);
}
/* AutomatisationCIrco
	Modifie l'tat du site d'une circo en fonction des dates d'ouverture et de fermeture des inscriptions.
	Efface ces dates lorsque le dlai est dpass.
	Convoque les stagiaires si le dlai d'inscription se termine.
*/
function automatisationCirco($id_circo,$h)
{
	$r=query("SELECT stag_etat,dt_ouverture,dt_fermeture,NOW() FROM circos WHERE id_circo=$id_circo",$h);
	if (!$r) return;
	$row=@mysqli_fetch_row($r);
	$dt_ouverture=$row[1];
	$dt_fermeture=$row[2];
	if (!$dt_ouverture && !$dt_fermeture) return;
	$stag_etat=$row[0];
	$nouv_etat=-1;
	$maintenant=$row[3];
	if($dt_ouverture && $maintenant<$dt_ouverture) $nouv_etat=0;
	else if ($dt_ouverture && $maintenant>=$dt_ouverture && $stag_etat==0 && !$dt_fermeture) $nouv_etat=1;
	else if ($dt_ouverture && $dt_fermeture && $maintenant>=$dt_ouverture && $maintenant < $dt_fermeture) $nouv_etat=1;
	else if ($dt_fermeture && $maintenant>=$dt_fermeture && $stag_etat<2) $nouv_etat=2;
	
	if ($nouv_etat>=0 && $nouv_etat!=$stag_etat) 
		query("UPDATE circos SET stag_etat=$nouv_etat WHERE id_circo=$id_circo",$h);
	// supprime l'automatisation si les dates sont dpasses
	if ( ($dt_fermeture!='' && $maintenant>=$dt_fermeture)||($dt_ouverture!='' && $dt_fermeture=='' && $maintenant>=$dt_ouverture)) {
		query("UPDATE circos SET dt_ouverture=NULL, dt_fermeture=NULL WHERE id_circo=$id_circo",$h);
	}
	// convoque automtiquement les stagiaires si nouv_etat=2
	if ($nouv_etat==2){
		$q="SELECT id_circo FROM circos WHERE type_circo=0 AND stag_etat <2 AND dt_fermeture IS NOT NULL AND dt_fermeture <= '$maintenant'";
		$circos[]=$id_circo;
		$r=query($q,$h);
		while ($row=@mysqli_fetch_row($r)) $circos[]=$row[0];
		$id_circos=implode(',',$circos);
		query("UPDATE circos SET stag_etat=2, dt_ouverture=NULL, dt_fermeture=NULL WHERE id_circo IN ($id_circos)",$h);
		convoquerInscrits($id_circos,true,$h,false);
	}
}

// Convoquer tous les stagiaires d'une circo ou plusieurs circos aux animations qu'ils ont choisies,  condition que la convocation n'existe pas dj. Retourne un message.
// si $exclure_traites est vrai, on exclut les inscriptions qui ont dj t traites	

function convoquerInscrits($id_circos,$exclure_traites,$h, $messages=true)
{
	global $erreur;
	$convoques=0;
	$total=0;
	$ignores=0;
	$msg='';
	// t contient la liste des stagiaires inscrits et non convoqus  des sances
	$q="CREATE TEMPORARY TABLE t(id_inscr INTEGER UNSIGNED, id_seance INTEGER UNSIGNED,id_stagiaire INTEGER UNSIGNED,max INTEGER) ENGINE MyISAM";
	query($q,$h);
	$q="INSERT INTO t(id_stagiaire,id_seance,max,id_inscr) 
SELECT inscriptions.id_stagiaire, inscriptions.id_seance, seances.max, inscriptions.id_inscr
FROM inscriptions
INNER JOIN stagiaires ON inscriptions.id_stagiaire = stagiaires.id_stagiaire
INNER JOIN ecoles ON stagiaires.id_ecole = ecoles.id_ecole
AND ecoles.id_circo IN ($id_circos)
INNER JOIN seances ON inscriptions.id_seance = seances.id_seance
LEFT JOIN convocations ON convocations.id_stagiaire = inscriptions.id_stagiaire
AND convocations.id_seance = inscriptions.id_seance
WHERE convocations.id_convoc IS NULL";
	if ($exclure_traites) $q.=" AND inscriptions.traite=0";
	$r=query($q,$h);
	if ($messages) $total=@mysqli_affected_rows($h);
	query ("UPDATE inscriptions INNER JOIN t ON t.id_inscr=inscriptions.id_inscr SET traite=1",$h);
	// traiter les sances sans maximum
	query("INSERT INTO convocations(id_seance, id_stagiaire) SELECT id_seance,id_stagiaire FROM t WHERE max=0",$h);
	if ($messages) $convoques+=@mysqli_affected_rows($h);
	// u contient la liste des sances pourvues d'un maximum, pour lesquelles il faut convoquer des stagiaires
	$q="CREATE TEMPORARY TABLE u(id_seance INTEGER UNSIGNED, max INTEGER) ENGINE MyISAM";
	query($q,$h);
	$q="INSERT INTO u(id_seance,max) 
SELECT 	id_seance,max 
FROM t
WHERE t.max>0
GROUP BY t.id_seance";
	query($q,$h); // u contient les sances avec maximum
	// traiter rapidement les sances avec maximum : nb est le nombre maximum de places encore disponibles pour chaque sance
	// L'instruction LIMIT ayant des... limites (on ne peut pas uiliser un champ dans LIMIT, uniquement une valeur), on utilisera donc une procdure stocke
	query("DROP PROCEDURE IF EXISTS convoquer",$h);
	$q="CREATE PROCEDURE convoquer(OUT nb_convoc INTEGER)
BEGIN
	 DECLARE v_finished INTEGER DEFAULT 0;
	 DECLARE v_id_seance INTEGER DEFAULT 0;
	 DECLARE v_nb INTEGER DEFAULT 0;
	 DEClARE curseur CURSOR FOR 
		SELECT u.id_seance, u.max-count( convocations.id_convoc ) AS nb
		FROM u
		LEFT JOIN convocations ON convocations.id_seance = u.id_seance
		GROUP BY u.id_seance
		HAVING nb>0;
	 DECLARE CONTINUE HANDLER FOR NOT FOUND SET v_finished = 1;
	OPEN curseur;
	SET nb_convoc = 0;
	boucle: LOOP
	FETCH curseur INTO v_id_seance, v_nb;
	IF v_finished = 1 THEN 
		LEAVE boucle;
	END IF;	
	INSERT INTO convocations (id_seance,id_stagiaire) SELECT id_seance, id_stagiaire FROM t WHERE id_seance=v_id_seance ORDER BY id_inscr LIMIT v_nb;
	SET nb_convoc = nb_convoc + ROW_COUNT();
	END LOOP boucle;
	CLOSE curseur;
END";
	query($q,$h);
	$q="SET @nb_convoc=0";
	query($q,$h);
	$q="CALL convoquer(@nb_convoc);";
	query($q,$h);
	if ($messages) {
		$convoques+=queryValue("SELECT @nb_convoc",$h);
	}
	query("DROP PROCEDURE IF EXISTS convoquer",$h);
	query("DROP TEMPORARY TABLE u",$h);
	query("DROP TEMPORARY TABLE t",$h);
	$msg='';
	if ($messages) {
		$ignores=$total-$convoques;
		$msg.="$convoques convocation(s) effectues. ";
		if ($ignores) $msg.="$ignores inscription(s) sont ignore(s) car le maximum est dj atteint. "; 
		$n=queryValue("SELECT COUNT(*) FROM convocations,stagiaires,ecoles WHERE convocations.id_stagiaire=stagiaires.id_stagiaire AND stagiaires.id_ecole=ecoles.id_ecole AND ecoles.id_circo IN ($id_circos)",$h);
		$msg.="Il y a maintenant $n convocation(s) dans la base. ";
	}
	return $msg;
}

?>