<?php
/* 
	Fonctions sur les intervenants
	Circon'script PHP Script
	Version 7.0.3 
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/
function exporterInterventions($h,$fp,$id_intervenant)
{
	$q="SELECT interventions.id_date, seances.id_seance,seances.max, seances.cond,dates.date, dates.lieu, dates.remarque as dates_remarque,dates.horaire,dates.duree, seances.max, seances.public, animations.intitule, animations.description, animations.remarque as anim_remarque, animations.lien,circos.libelle AS circo, circos.id_circo, circos.courriel AS courriel_circo, circos.stag_etat as etat, domaines.annee FROM (interventions, dates, seances, animations, positions,domaines, circos) WHERE interventions.id_intervenant=$id_intervenant AND interventions.id_date=dates.id_date AND dates.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim  AND positions.id_anim=animations.id_anim AND positions.id_domaine= domaines.id_domaine AND domaines.id_circo=circos.id_circo AND animations.id_circo=domaines.id_circo ORDER BY domaines.annee ASC, dates.date ASC, dates.horaire ASC";
	$r=query($q,$h);
	fputs($fp,'"plan";"date";"dure";"lieu";"public";"autres intervenants";"Intitul";"Description";"Remarque";"lien";"Organisateur";"Courriel Org.";"Etat";"Nb. inscr.";"Nb. conv.";"Max"');
	fputs($fp,"\n");
	// plan
	while ($row=@mysqli_fetch_array($r)) {
		$id_seance=$row['id_seance'];
		$id_date=$row['id_date'];
		if ($row['annee']==0) fputs($fp,'"actuel";');
		else fputs($fp,'"futur";');
		//date
		fprintf($fp,"\"%s\";",dateSQLEnSaisie($row['date']));
		//dure
		fprintf($fp,"\"%s\";",reelEnHeureTxt($row['duree']));
		// lieu
		$lieu=$row['lieu'];
		fputs($fp,"\"$lieu\";");
		//public	
		fprintf($fp,"\"%s\";",$row['public']);
		// autres intervenants
		$int=strip_tags(intervenantsCourriel($row['id_date'],$id_intervenant,$h));
		fputs($fp,"\"$int\";");
		//intitul
		fprintf($fp,"\"%s\";",$row['intitule']);
		//description
		fprintf($fp,"\"%s\";",$row['description']);
		//remarque
		fprintf($fp,"\"%s\";",$row['anim_remarque']);
		// lien
		fprintf($fp,"\"%s\";",$row['lien']);
		//organisateur
		fprintf($fp,"\"%s\";",$row['circo']);
		//courriel organisateur
		fprintf($fp,"\"%s\";",$row['courriel_circo']);
		//tat du site
		$etat=strip_tags(trouverEtat($row['id_circo'],$id_seance,$row['etat'],$h));
		fputs($fp,"\"$etat\";");
		//nb inscr et nv conv	
		$max=$row['max'];
		$nb_inscr=queryValue("SELECT COUNT(*) FROM inscriptions WHERE id_seance=$id_seance",$h);
		$nb_conv=queryValue("SELECT COUNT(*) FROM convocations WHERE id_seance=$id_seance",$h);
		if (!$nb_inscr) $nb_inscr='0';
		if (!$nb_conv) $nb_conv='0';
		fputs($fp,"\"$nb_inscr\";\"$nb_conv\";\"$max\"\n");
	}		
	
}

/*
	$plan==0: animations auxquelles participe l'intervenant, vue administrateur
	$plan==1: idem, vue par l'intervenant lui-mme

*/

function afficherInterventions($h,$id_intervenant,$plan)
{
	$q="SELECT dates.tri,interventions.id_date, seances.id_seance,seances.max, seances.cond,dates.date, dates.lieu, dates.remarque as dates_remarque,dates.horaire,dates.duree, seances.max, seances.public, animations.intitule, animations.description, animations.remarque as anim_remarque, animations.lien,circos.libelle AS circo, circos.id_circo, circos.courriel AS courriel_circo, circos.stag_etat as etat, domaines.annee, COUNT(d2.id_date) AS nb_dates 
FROM (interventions, dates, seances, animations, positions,domaines, circos) 
LEFT JOIN dates as d2 ON d2.id_seance=seances.id_seance
WHERE interventions.id_intervenant=$id_intervenant AND interventions.id_date=dates.id_date AND dates.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim  AND positions.id_anim=animations.id_anim AND positions.id_domaine= domaines.id_domaine AND domaines.id_circo=circos.id_circo AND animations.id_circo=domaines.id_circo 
GROUP BY dates.id_date
ORDER BY domaines.annee ASC, dates.date ASC, dates.horaire ASC";
/*

	$q="SELECT interventions.id_date, seances.id_seance,seances.max, seances.cond,dates.date, dates.lieu, dates.remarque as dates_remarque,dates.horaire,dates.duree, seances.max, seances.public, animations.intitule, animations.description, animations.remarque as anim_remarque, animations.lien,circos.libelle AS circo, circos.id_circo, circos.courriel AS courriel_circo, circos.stag_etat as etat, domaines.annee FROM (interventions, dates, seances, animations, positions,domaines, circos) WHERE interventions.id_intervenant=$id_intervenant AND interventions.id_date=dates.id_date AND dates.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim  AND positions.id_anim=animations.id_anim AND positions.id_domaine= domaines.id_domaine AND domaines.id_circo=circos.id_circo AND animations.id_circo=domaines.id_circo ORDER BY domaines.annee ASC, dates.date ASC, dates.horaire ASC";
*/
	$r=query($q,$h);
	print "<table>\n";
	print "<tr class=\"table_entete\">\n";
	print "<td>Date</td>\n";
	print "<td>Lieu &amp; public,<br/>autres intervenants</td>\n";
	print "<td>Animation</td>\n";
	print "<td>Org, courriel</td>\n";
	if ($plan==0) {
		print "<td>Nb inscr</td>\n";
		print "<td>Nb conv</td>\n";
		print "<td>Feuilles prsence</td>\n";
		print "<td>Courriels stagiaires</td>\n";
	}
	else if ($plan==1) {
		print "<td>Opration en cours</td>\n";
		print "<td>Nb inscr</td>\n";
		print "<td>Nb conv</td>\n";
		print "<td>Feuilles prsence</td>\n";
		print "<td>Courriels stagiaires</td>\n";
	}
	print "</tr>\n";
	$count=1;
	$prec_annee=0;	
	$date_courante=date("Y-m-d");
	$date_imprimee='';
	while ($row=@mysqli_fetch_array($r)) {
		$id_seance=$row['id_seance'];
		$id_date=$row['id_date'];
		if ($prec_annee==0 && $row['annee']==1) 
			printf ("<tr class=\"survol\"><td><h4>Plan futur</h4></td><td colspan=\"%d\"><hr/></td></tr>\n", $plan==0?3:8);
		$prec_annee=$row['annee'];
		print "<tr class=\"ligne_bas\">\n";
		
		//date et remarque ventuelle
		if ($date_courante!='' && $row['date']>=$date_courante) {
			if ($date_imprimee=='') {
				$date_imprimee=$row['date'];
				print "<td class=\"date_surbrille\">";
			}
			else if ($date_imprimee==$row['date']) {
				print "<td class=\"date_surbrille\">";
			}
			else {
				print "<td class=\"survol\">";
				$date_imprimee='';
				$date_courante='';
			}
		
		}
		else print "<td class=\"survol\">";
		print"<a name=\"date_$id_date\"></a>";

		if ($row['date']<'9999-12-30')
			printf("<h4>%d: %s - %s</h4>\n",$count, dateSQLEnTexte($row['date']),horaireSqlEnHeure($row['horaire']));
		else
			printf("<h4>%d: %s</h4>\n",$count, dateSQLEnTexte($row['date']));
		
		
		printf("<p>dure: %s</p>",reelEnHeure($row['duree']));
		if ($row['nb_dates']>1) {
			printf("<p>sance %d sur %d</p>",intval($row['tri'])+1,intval($row['nb_dates']));
	
		}
		
		if ($row['dates_remarque'])
			printf("<p class=\"remarque\">%s</p>\n",htmlentities($row['dates_remarque'],ENT_COMPAT,'ISO-8859-15'));
		if ($row['cond']) print"<p class=\"remarque\">Sance supplmentaire, ouverte si besoin.</p>\n";
		print "</td>\n";

		//lieu et public
		print "<td class=\"survol\">";
		$lieu=$row['lieu'];
		if ($lieu=='' && $row['date']!='9999-12-30') $lieu=' dfinir';
		$lieu=htmlentities($lieu,ENT_COMPAT,'ISO-8859-15');
		if ($lieu && $row['public'])
			printf("<p>%s (%s)</p>\n",$lieu,htmlentities($row['public'],ENT_COMPAT,'ISO-8859-15'));
		else if ($row['public'])		
			printf("<p>%s</p>\n",htmlentities($row['public'],ENT_COMPAT,'ISO-8859-15'));
		else if ($lieu) 
			print"<p>$lieu</p>\n";
		else print "<p>&nbsp;</p>\n";
		
		//intervenants
		$int=intervenantsCourriel($row['id_date'],$id_intervenant,$h);
		if ($int) print "<p>$int</p>\n";
		print "</td>\n";
		// animation et tous paramtres
		print "<td class=\"survol\">";
		if ($plan==0)
			printf("<h5><a href=\"javascript:jsEditer(%d)\">%s</a></h5>\n",$row['id_date'],htmlentities($row['intitule'],ENT_COMPAT,'ISO-8859-15'));		
		else
			printf("<h5>%s</h5>\n",htmlentities($row['intitule'],ENT_COMPAT,'ISO-8859-15'));		
		$lien='';
		if ($row['lien'])
			$lien=sprintf("<a href=\"javascript:ouvreLien('%s')\" title=\"Lien externe vers des informations. S'ouvre dans une nouvelle fen&ecirc;tre.\"><img src=\"images/lien_externe.png\" alt=\"lien externe\" width=\"16\" height=\"16\" /></a>&nbsp;",$row['lien']);
		if ($row['description']) {
			printf("<p>%s%s</p>\n",$lien,htmlentities($row['description'],ENT_COMPAT,'ISO-8859-15'));
			$lien='';
		}
		if ($row['anim_remarque']){
			printf("<p class=\"remarque\">%s%s</p>\n",$lien,htmlentities($row['anim_remarque'],ENT_COMPAT,'ISO-8859-15'));
			$lien='';
		}
		if ($lien) 
			print"<p>$lien</p>\n";
		
		print "</td>\n";
		if ($row['courriel_circo']=='')
			printf( "<td><p>%s</p></td>\n",htmlentities($row['circo'],ENT_COMPAT,'ISO-8859-15'));
		else
			printf( "<td><p><a href=\"mailto:%s\">%s</a></p></td>\n",$row['courriel_circo'],htmlentities($row['circo'],ENT_COMPAT,'ISO-8859-15'));
		if ($plan==0) {
			$nb_inscr=queryValue("SELECT COUNT(*) FROM inscriptions WHERE id_seance=$id_seance",$h);
			$nb_conv=queryValue("SELECT COUNT(*) FROM convocations WHERE id_seance=$id_seance",$h);
			$max=$row['max'];
			if ($max>0) {
				$inscr="$nb_inscr/$max";
				$conv="$nb_conv/$max";
			}
			else {
				$inscr=$nb_inscr;
				$conv=$nb_conv;
			}
			print "<td>\n";
			if ($nb_inscr>0) 
				print "<p><a href=\"javascript:ouvre('adm_voir_stagiaires.php?inscrits=$id_seance')\">$inscr</a></p>\n";
				else print"<p>$inscr</p>\n";
			print "</td>\n";			
			print "<td>\n";
			if ($nb_conv>0) 
				print "<p><a href=\"javascript:ouvre('adm_voir_stagiaires.php?convoques=$id_seance')\">$conv</a></p>\n";
				else print"<p>$conv</p>\n";
			print "</td>\n";			
			$id_date=$row['id_date'];
			print "<td>\n";
			if ($nb_conv>0)
				print "<p><a href=\"adm_feuille_presence_imprime.php?id_date=$id_date\" target=\"_blank\"><img src=\"images/b_stagiaires.png\" alt=\"feuille de prsence\" /></a></p>\n";
			else print "<p>&nbsp;</p>\n";
			print "</td>\n";	
			//courriel
			print "<td>\n";
			if ($nb_conv>0) print"<p><a href=\"adm_int_courriels.php?id_date=$id_date&amp;id_intervenant=$id_intervenant&amp;url_ret=adm_interventions.php\"><img src=\"images/internet-mail.png\" alt=\"courriel aux stagiaires\" /></a></p>\n";
			else print "<p>&nbsp;</p>\n";
			print "</td>\n";	
		}			
		else if ($plan==1) {
			$id_circo=$row['id_circo'];
			$etat=trouverEtat($id_circo,$id_seance,$row['etat'],$h);
			print "<td>\n";
			print "<p>$etat</p>\n";
			print "</td>\n";
			$max=$row['max'];
			$nb_inscr=queryValue("SELECT COUNT(*) FROM inscriptions WHERE id_seance=$id_seance",$h);
			$nb_conv=queryValue("SELECT COUNT(*) FROM convocations WHERE id_seance=$id_seance",$h);
			if ($max>0) {
				$inscr="$nb_inscr/$max";
				$conv="$nb_conv/$max";
			}
			else {
				$inscr=$nb_inscr;
				$conv=$nb_conv;
			}
			print "<td>\n";
			if ($nb_inscr>0) 
				print "<p><a href=\"javascript:ouvre('adm_voir_stagiaires.php?inscrits=$id_seance')\">$inscr</a></p>\n";
				else print"<p>$inscr</p>\n";
			print "</td>\n";			
			print "<td>\n";
			if ($nb_conv>0) 
				print "<p><a href=\"javascript:ouvre('adm_voir_stagiaires.php?convoques=$id_seance')\">$conv</a></p>\n";
				else print"<p>$conv</p>\n";
			print "</td>\n";			
			$id_date=$row['id_date'];
			print "<td>\n";
			if ($nb_conv>0)
				print "<p><a href=\"adm_feuille_presence_imprime.php?id_date=$id_date\" target=\"_blank\"><img src=\"images/b_stagiaires.png\" alt=\"feuille de prsence\" /></a></p>\n";
			else print "<p>&nbsp;</p>\n";
			print "</td>\n";	
			//courriel
			print "<td>\n";
			if ($nb_conv>0) print"<p><a href=\"int_courriels.php?id_date=$id_date&amp;url_ret=int_interventions.php\"><img src=\"images/internet-mail.png\" alt=\"courriel aux stagiaires\" /></a></p>\n";
			else print "<p>&nbsp;</p>\n";
			print "</td>\n";	
					
		}
		print "</tr>\n";
		++$count;
	}
	
	print "</table>\n";
		
}
/* 
	Fonction de formatage d'une liste d'intervenants
*/

function intervenantsCourriel($id_date,$id_intervenant,$h)
{
	$r=query("SELECT civilite, nom, prenom, fonction, courriel FROM intervenants, interventions WHERE interventions.id_date=$id_date AND interventions.id_intervenant<>$id_intervenant AND interventions.id_intervenant=intervenants.id_intervenant ORDER BY nom ASC",$h);
	$int='';
	while ($row=@mysqli_fetch_row($r)) {
		$s='';
		$civ=$row[0];
		$nom=$row[1];
		$prenom=$row[2];
		$fonction=$row[3];
		$courriel=$row[4];
		if ($courriel) $s.="<a href=\"mailto:$courriel\">";
		if ($nom && $prenom) $s.=htmlentities("$prenom $nom",ENT_COMPAT,'ISO-8859-15');
		else if ($nom) {
			if($civ==0) $s.=htmlentities("M $nom",ENT_COMPAT,'ISO-8859-15');
			else if ($civ==1) $s.=htmlentities("Mme $nom",ENT_COMPAT,'ISO-8859-15');
			else $s.=$nom;
		}
		if ($courriel) $s.='</a>';
		if ($s && $fonction) $s.=htmlentities(" ($fonction)",ENT_COMPAT,'ISO-8859-15');
		if ($s) {
			if ($int) $int.=', ';
			$int.=$s;
		}
	}
	return $int;
}
function trouverEtat($id_circo,$id_seance,$etat_courant,$h)
{
	$etat='';
	$q="SELECT partages.id_circo, circos.stag_etat AS etat, circos.libelle_court FROM partages, circos WHERE partages.accepte =1 AND partages.id_seance = $id_seance AND partages.id_circo=circos.id_circo GROUP BY circos.id_circo ORDER BY circos.libelle_court";
	$r2=query($q,$h);
	if (@mysqli_num_rows($r2)<=1) 
		switch ($etat_courant) {
			case 0: $etat='ferme';break;
			case 1: $etat='inscriptions en cours';break;
			case 2: $etat='convocations en cours';break;
			case 3: $etat='convocations publies';break;
			default: $etat='inconnu';break;
		}
		else {
			$etat='';
			$circos=array();
			for ($i=0;$i<4;++$i) $circos[$i]='';
			while ($row2=@mysqli_fetch_array($r2)) {
				$i=$row2['etat'];
				if ($i>3) continue;
				if ($circos[$i]!='') $circos[$i].=', ';
				$circos[$i].=$row2['libelle_court'];
			}
			for ($i=0;$i<4;++$i) 
				if ($circos[$i]!='') {
				switch($i) {
					case 0: $etat.='<em>Ferme: </em>';break;
					case 1: $etat.='<em>Inscriptions en cours: </em>';break;
					case 2: $etat.='<em>Convocations en cours: </em>';break;
					case 3: $etat.='<em>Convocations publies: </em>';break;
				}
				$etat.=$circos[$i];
				$etat.=".<br/>\n";	
			}	
		}
	return $etat;
}
function getSession()
{
	$t='abcdefghijklmnopqrstuvwxyz01234567890123456789';
	$out='';
	$l=strlen($t);
	for ($i=0;$i<12;++$i) {
		if ($i==4||$i==8) $out.='-';
		$x=rand(0,$l-1);
		$out.=substr($t,$x,1);
	}
	return $out;	
}

function updateIntervenantICAL($h,$id_intervenant,$bical)
{
	global $erreur;
	$ical_session='';
	query("UPDATE intervenants SET ical_session = NULL, ical_timestamp=NULL, ical_session=NULL WHERE id_intervenant=$id_intervenant",$h);
	if ($bical) {
		do {
			$ical_session=getSession();	
			$n=queryValue("SELECT COUNT(*) FROM intervenants WHERE ical_session='$ical_session'",$h);
		}while ($n);
		$b=query("UPDATE intervenants SET ical_session='$ical_session', ical_timestamp=NULL, ical_cache=NULL WHERE id_intervenant=$id_intervenant",$h);
		if (!$b) $ical_session='';
		
	}
	return $ical_session;
}
	
?>
