<?php
/* 
	Fonctions de traitement des mots de passe
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/

// Etablir la connexion sur un compte utilisateur
//retour: 0 si login non trouv , -1 si login trouv mais erreur sur mot de passe, ou id_uti si trouv et OK.
// E: mdp est cod en MD5
/*
$_SESSION['circonscript7_sso']: variable cre lorsque l'utilisateur a utilis les services d'authentification SSO

*/

function connexion($login, $mdp, $h, $seulement_admin=false)
{
	global $erreur,$cle_aes;
	$login=myEscapeString($h,normaliseT($login,256));

	if (!testeMd5(normaliseT($mdp,32))) return 0;
	if ($mdp=='' || $login=='') return 0;
	$r=query("SELECT mdp, codage, id_uti FROM utilisateurs WHERE login='$login'",$h);
	if (@mysqli_num_rows($r)==0) return 0;
	while ($row=@mysqli_fetch_row($r)) {
		$mdp_base=$row[0];
		$resultat=false;
		$codage=$row[1];
		if ($codage==1) {// md5? 
			$resultat=$mdp_base==$mdp;
		}
		else if ($codage==2)  { //AES
			if ($cle_aes=='') continue; // aucune connexion possible si cl AES non dfinie
			$mdp_base2=myEscapeString($h,$mdp_base);
			$mdp_lu1=queryValue("SELECT AES_DECRYPT('$mdp_base2', '$cle_aes')",$h);
			$mdp_lu2=md5($mdp_lu1);
			$resultat=$mdp_lu2==$mdp;
		}
		else $resultat=$mdp==md5($mdp_base);
		if ($resultat) {
			$id_uti=$row[2];
			if (!$seulement_admin) return $id_uti; // id_uti	
			// vrifier s'il existe un admin principal pour ce compte
			$n=queryValue("SELECT COUNT(*) FROM administrateurs WHERE id_uti=$id_uti AND type_admin=1",$h);
			return $n==0? 0 : $id_uti;
		}
	}
	return -1; // login trouv mais pas mdp
}
function enregistreAcces($id_uti,$h,$interface=0)
{
	// enregistre la prcdente date de connexion 
	$dtConnexion=queryValue("SELECT dt_connexion FROM utilisateurs WHERE id_uti=$id_uti",$h);
	$_SESSION['circonscript7_compte_dtconnexion']=$dtConnexion;
	query("UPDATE utilisateurs SET dt_connexion=NOW(), acces='$interface' WHERE id_uti=$id_uti",$h);
}

/*
	retourne true si mot de passe OK 
	Les caractres accepts sont dans la chane $t et doit comporter au moins 4 caractres 
*/
function motDePasse($mdp)
{
	if (strlen($mdp)<4) return false;
	return preg_match("#^[abcdefghijklmnopqrstuvwxyz0123456789_\-]+$#",strtolower($mdp));
}
/*
	id_uti: utilisateur  qui il faut envoyer le courriel
	courriel: adresse de courriel de l'utilisateur. Si vide, on utilise le login si c'est une adresse courriel; si login n'est pas courriel, erreur. 
	L'adresse de courriel, si elle est valide, est toujours utilise  la place du login.
	adr_de: adresse courriel de l'expditeur du message. Si vide, adresse de l'administrateur courant
	nom_de: nom de l'expditeur du message; si vide, nom de l'administrateur courant
	
	Cette fonction est susceptible de renseigner le champ hash d'un utilisateur, si le codage est le md5 et si le hash n'est pas renseign.
	forcer: si true, on force l'affichage du login et du mot de passe mme si on est dans le portail SSO (sso_login true, sso_bloque_exterieur true)
*/
function publipostage($id_uti, $h,$courriel='',$adr_de='',$nom_de='', $objet='', $cci='',$forcer=false)
{
	global $erreur,$cle_aes,$url_site, $use_sso,$sso_adresse_portail,$sso_portail,$sso_bloque_exterieur;
	if (isset($_SESSION['circonscript7_id_admin'])) $id_admin=$_SESSION['circonscript7_id_admin'];
	else $id_admin=0;
	if (isset($_SESSION['circonscript7_id_circo'])) $id_circo=$_SESSION['circonscript7_id_circo'];
	else $id_circo=0;
	$r=query("SELECT login, mdp,codage, sso_login,hash FROM utilisateurs WHERE id_uti=$id_uti",$h);
	$row=@mysqli_fetch_row($r);
	if (@mysqli_num_rows($r)==0) {
		$erreur="Identificateur de l'utilisateur incorrect.";
		return 0;
	}
	$login=$row[0];
	if (!testeEmail($courriel)) {
		if (testeEMail($login)) $courriel=$login;
		else  {	
			$erreur="Cet utilisateur n'a pas d'adresse de courriel valide : ".htmlentities($login,ENT_COMPAT,'ISO-8859-15') ;
			return 0;	
		}
	}
	$mdp=$row[1];
	$codage=$row[2];
	$sso_login=$row[3];
	$hash=$row[4];
	if ($codage==2) 
		$mdp=queryValue("SELECT AES_DECRYPT(mdp,'$cle_aes') FROM utilisateurs WHERE id_uti=$id_uti",$h);
	if ($hash=='bloque') {
		$erreur="Opration annule: l'administrateur principal a bloqu l'envoi des informations de connexion pour cet utilisateur. ";
		return 0;
	}
	if (!$objet) $objet="Vos paramtres de connexion  Circon'script";
	if ($adr_de=='') {
		if ($id_admin) {
			$r=query("SELECT courriel, nom, id_uti FROM administrateurs WHERE id_admin=$id_admin",$h);
			$row=@mysqli_fetch_row($r);
			$adr_de=$row[0];
			$nom_de=$row[1];
			$id_uti_admin=$row[2];
			if (!$adr_de) {
				$r=query("SELECT login FROM utilisateurs WHERE id_uti=$id_uti_admin",$h);
				$row=@mysqli_fetch_row($r);
				if (testeEmail($row[0])) $adr_de=$row[0];
			}
		}			
		if (! $adr_de && $id_circo) {
			$r=query("SELECT courriel, libelle FROM circos WHERE id_circo=$id_circo",$h);
			$row=@mysqli_fetch_row($r);
			$adr_de=$row[0];
			$nom_de=$row[1];
		}
		if (!$adr_de) {
			$r=query("SELECT courriel,nom_admin FROM general",$h);
			$row=@mysqli_fetch_row($r);
			$adr_de=$row[0];
			$nom_de=$row[1];
		}
	}
	if ($adr_de=='' || !testeEmail($adr_de)) {
		$erreur="L'administrateur (vous! $nom_de) n'a pas d'adresse de courriel valide, ni dans le compte 'admin', ni dans l'identifiant, et l'adresse de courriel par dfaut n'est pas dfinie dans les paramtres gnraux d'administration. ";
		if ($id_circo) $erreur.=" Aucune adresse de courriel par dfaut n'a t dfinie dans les paramtres de la circonscription. ";
		return 0;
	}
	if ($nom_de=='') $nom_de=$adr_de;
	$header=implode(file('_header.inc.txt'));
	if ($header=='') {
		$erreur="fichier _header.inc.txt non trouv ou incorrect sur le site";
		return 0;
	}
	$header=str_replace('<title></title>','<title>Vos param&egrave;tres de connexion &agrave; Circon\'script</title>',$header);

	// url du site...
	if ($url_site=='') {
		$domaine=$_SERVER['HTTP_HOST'];
		$path=$_SERVER['SCRIPT_NAME'];
		$t=explode('/',$path);
		if (sizeof($t)>1) {
			unset($t[sizeof($t)-1]);
			$path=implode('/',$t);
		}
		else $path='';
		$http='http';
		if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS']=='on') $http='https';
		$site="$http://$domaine$path/index.php";
	}
	else $site=$url_site."/index.php";
	$lien='';
	if ($codage==1) {
		// crer un lien vers le site pour la rinitialisation.
		if (!$hash) {
			$hash=uniqId().md5(mt_rand()); 
			query("UPDATE utilisateurs SET hash='$hash' WHERE id_uti=$id_uti",$h);
		}
		if ($url_site=='') 
			$lien="$http://$domaine$path/mdp_init.php?ref=".$hash;
		else
			$lien=$url_site.'/mdp_init.php?ref='.$hash;
	}
	// si l'utiliateur est superadmin, envoyer tous les paramtres de connexion
	if ($use_sso && !$forcer) 
		$forcer=queryValue("SELECT type_admin FROM administrateurs WHERE id_uti=$id_uti",$h);
	$frontiere='----='.md5(uniqid(mt_rand()));
	//-----------------TEXTE SIMPLE
	$msg_txt="PARAMETRES DE CONNEXION A CIRCON'SCRIPT\n\n";
	$msg_txt.="Bonjour,\n";
	$msg_txt.="Ceci est un courriel automatique envoy par le logiciel Circon'script qui gre les animations pdagogiques.\n\n";
	$msg_txt.="Voici vos paramtres de connexion.\n\n";
	if ($use_sso && $sso_login!='') {
		$msg_txt.="Connexion via le portail $sso_portail:\n";
		if ($sso_adresse_portail)
			$msg_txt.="Adresse du portail $sso_portail : $sso_adresse_portail\n";
		$msg_txt.="Votre identifiant au portail : $sso_login\n";
		$msg_txt.="Votre mot de passe de connexion au portail $sso_portail n'est pas connu de Circon'script.\n\n";	
	}
	if ($forcer || !($use_sso && $sso_login!='' && $sso_bloque_exterieur)) {
		$msg_txt.="Accs direct  Circon'script:\n";
		$msg_txt.="adresse du site: $site\n";
			$msg_txt.="Votre identifiant  : $login\n";
		if ($codage!=1)
			$msg_txt.="Votre mot de passe: $mdp\n";
		else 
			$msg_txt.="Votre mot de passe ne peut tre communiqu car il est crypt. Vous pouvez le rinitialiser en cliquant sur ce lien:\n$lien\n\n";
	}
	$msg_txt.="\nS'il y a une erreur sur la personne et que vous ne devriez pas tre le destinataire de ce message, nous vous remercions de bien vouloir le signaler immdiatement par retour de ce courriel.\n\n";

	$msg_txt.="Cordialement,\n";
	$msg_txt.="l'administrateur.\n\n";
	//---------------------HTML	
	$msg_html='';
	$msg_html.="<body>\n<div id=\"conteneur\">\n<h1>Param&egrave;tres de connexion &agrave; Circon'script</h1>\n";
	$msg_html.="<p>Bonjour,</p>\n";
	$msg_html.="<p>Ceci est un courriel automatique envoy&eacute; par le logiciel Circon'script qui g&egrave;re les animations p&eacute;dagogiques.</p>\n";
	$msg_html.="<p>Voici vos param&egrave;tres de connexion.</p>\n";
	
	if ($use_sso && $sso_login!='') {
		$msg_html.="<h3>Connexion via le portail $sso_portail:</h3>\n";
		if ($sso_adresse_portail)
			$msg_html.="<p>Adresse du portail $sso_portail : <a href=\"$sso_adresse_portail\">$sso_adresse_portail</a></p>\n";
		$msg_html.="<p>Votre identifiant au portail : $sso_login</p>\n";
		$msg_html.="<p>Votre mot de passe de connexion au portail $sso_portail n'est pas connu de Circon'script.</p>\n\n";	
	}
	if ($forcer || !($use_sso && $sso_login!='' && $sso_bloque_exterieur)) {
		$msg_html.="<h3>Accs direct  Circon'script</h3>\n";
		$msg_html.="<p> Adresse du site: <a href=\"$site\">$site</a></p>\n";
		$msg_html.="<p>Votre identifiant  : $login</p>\n";
		if ($codage!=1)  
			$msg_html.=sprintf("<p>Votre mot de passe: %s</p>\n",htmlentities($mdp,ENT_COMPAT,'ISO-8859-15'));
		else
			$msg_html.="<p>Votre mot de passe ne peut &ecirc;tre communiqu&eacute; car il est crypt&eacute;. Vous pouvez le r&eacute;initialiser en cliquant sur ce lien:</p>\n<p><a href=\"$lien\">$lien</a></p>\n";
	}
	$msg_html.="<p>S'il y a une erreur sur la personne et que vous ne devriez pas &ecirc;tre le destinataire de ce message, nous vous remercions de bien vouloir le signaler imm&eacute;diatement par retour de ce courriel.</p>\n\n";
	$msg_html.="<p>Cordialement,</p>\n";
	$msg_html.="<p>l'administrateur.</p>\n";
	// ---------------HEADER
	$head="From: \"$nom_de\" <$adr_de>\r\n";
	$head.="Reply-To: $adr_de\r\n";
	if ($cci && $codage!=2) $head.="Bcc: $cci\r\n"; 
	$head.="MIME-Version: 1.0\r\n";
	$head.="Content-Type: multipart/alternative;\r\n";
	$head.="  boundary=\"$frontiere\";\r\n";
	//--------MESSAGE TEXTE
	$msg_final= "This is a multi-part message in MIME format.\n\n";
	$msg_final.='--'.$frontiere."\n";
	$msg_final.="Content-Type: text/plain; charset=\"ISO-8859-15\"\n";
	$msg_final.="Content-Transfer-Encoding: 8bit\n\n";
	$msg_final.=$msg_txt."\n\n";
	//----------MESSAGE HTML
	$msg_final.='--'.$frontiere."\n";
	$msg_final.="Content-Type: text/html; charset=ISO-8859-15\n";
	$msg_final.="Content-Transfer-Encoding: 8bit\n\n";
	$msg_final.=$header; // header html
	$msg_final.=$msg_html."\n";
	$msg_final.='--'.$frontiere."--\n";
	
	if (extension_loaded('mbstring')) {
		mb_internal_encoding('ISO-8859-15');
		$obj=mb_encode_mimeheader($objet, 'ISO-8859-15','Q',"\r\n");
	}
	else $obj=$objet;
	$b=@mail($courriel,$obj,$msg_final,$head);
	if (!$b) {
		$erreur.="Problme d'envoi de courriels. Processus interrompu.";
		return 0;
	}
	else query("UPDATE utilisateurs SET date_publipostage=NOW() WHERE id_uti=$id_uti",$h);
	return 1;
}
// Attribuer un compte  un utilisateur.
// si id_uti=0, nouveau compte ou rutilisation d'un existant; si login=='', alors cration du compte 'utilisateurXXX'
// si id_uti!=0, renommer le compte ou changer le password; dans ce cas, si mdp=='', ne pas changer le mdp 
// Si le compte existe dj, le mot de passe n'est pas modifi.
// Sinon, le nouveau mot de passe est insr sous forme provisoire
// retourne $id_uti ou 0 
// $info est renseign, ainsi que $erreur 
// NB: cette routine cre des utilisateurs orphelins qu'il convient de supprimer par ailleurs

function attribuerCompte($id_uti,$login, $mdp,&$info, $h,$codage=0,$refuser_reutilisation=false,$sso_login='')
{
	global $erreur,$use_sso, $sso_portail;
	$erreur='';
	$sso_login_esc=myEscapeString($h,$sso_login);
	$login_esc=myEscapeString($h,$login);

	if ($codage<0 || $codage>2) $codage=0;
	if (!$id_uti) { // crer un nouveau compte ou utiliser un compte existant si $refuser_reutilisation est false
		$id_uti_sso=0;
		if (!$mdp) {
			$erreur="AttribuerCompte: Mot de passe non dfini. ";
			return 0; // si pas de mot de passe, retour avec erreur
		}
		$mdp_esc=myEscapeString($h,$mdp);
		if ($sso_login) 
			$id_uti_sso=queryValue("SELECT id_uti FROM utilisateurs WHERE sso_login='$sso_login_esc'",$h);
		if ($login ) {
			$r=query("SELECT id_uti FROM utilisateurs WHERE login LIKE '$login_esc'",$h);
			if (@mysqli_num_rows($r)==0) { // pas d'utilisateurs ? On en cre un si le login SSO n'existe pas dj dans la base
				if ($id_uti_sso) {
					$erreur="Il existe dj un utilisateur avec cet identifiant SSO '$sso_login'.";
					return 0;
				}
				$q=sprintf("INSERT INTO utilisateurs(login, mdp, codage,sso_login) VALUES ('$login_esc','$mdp_esc','$codage',%s)",empty($sso_login)?"NULL":"'$sso_login_esc'");
				$r=query($q,$h);
				if ($erreur) return 0;
				$id_uti=@mysqli_insert_id($h);
				$info.="Le compte utilisateur '$login' a t cr. ";
			}
			else {// l'utilisateur existe. On le reprend si on en a le droit.
				if ($refuser_reutilisation) {
					$erreur.="Erreur: il existe dj un identifiant de connexion '$login'.";
					$id_uti=0;
				}
				else {
					$row=@mysqli_fetch_row($r);
					$id_uti=$row[0];
					$info.="L'identifiant de connexion dj existant '$login' a t utilis - pour se connecter, l'utilisateur doit maintenant renseigner le mot de passe de ce compte. ";
				}
			}
		}
		else if ($sso_login) {// pas de login mais il existe un sso_login
			if (!$id_uti_sso) { // il n'existe pas d'utilisateur avec ce sso_login: on le cre
				$r=query("INSERT INTO utilisateurs(login, mdp, codage, sso_login) VALUES('utilisateur','$mdp_esc','$codage','$sso_login')",$h);
				if ($erreur) return 0;
				$id_uti=@mysqli_insert_id($h);
				$login=loginGeneriqueUnique($id_uti,$h);
				query("UPDATE utilisateurs SET login='$login' WHERE id_uti=$id_uti",$h);
				$info.="Le compte utilisateur d'identifiant '$login' a t cr. ";
			}
			else 
				if ($refuser_reutilisation) {
					$erreur.="Erreur: il existe dj un identifiant de connexion SSO '$sso_login'.";
					$id_uti=0;
				}
				else {
					$id_uti=$id_uti_sso;	
					$info.="Le compte utilisateur d'identifiant SSO '$sso_login' a t rutilis. ";
				}
		}
		else { // pas de login ni de login_sso: en crer un. 
			$login='utilisateur';
			$mdp_esc=myEscapeString($h,$mdp);
			$q="INSERT INTO utilisateurs(login, mdp, codage,sso_login) VALUES ('$login','$mdp_esc','$codage',NULL)";
			$r=query($q,$h);
			if ($erreur) return 0;
			$id_uti=@mysqli_insert_id($h);
			$login=loginGeneriqueUnique($id_uti,$h);
			query("UPDATE utilisateurs SET login='$login' WHERE id_uti=$id_uti",$h);
			$info.="Le compte utilisateur d'identifiant '$login' a t cr. ";
		}
	}
	else {// id_uti existe
		$r=query("SELECT login,mdp, codage,sso_login FROM utilisateurs WHERE id_uti=$id_uti",$h);
		if (@mysqli_num_rows($r)==0) {
			$erreur="Utilisateur inexistant.";
			return 0;
		}
		$row=@mysqli_fetch_row($r);
		$login_lu=$row[0];
		if ($login=='' && $mdp=='') return $id_uti;
		$id_uti_nouv=0;
		$mdp_lu=$row[1];
		$codage_lu=$row[2];
		$sso_login_lu=$row[3];
		if ($login!='' && $login!=$login_lu) { // changer le login. Dans ce cas, se brancher sur un autre utilisateur ou renommer le compte ?
			$row=queryRow("SELECT id_uti,sso_login FROM utilisateurs WHERE login LIKE '$login' AND id_uti<>$id_uti",$h);
			$id_uti_nouv=$row[0];
			$sso_login_nouv=$row[1];
			
			if (!$id_uti_nouv) {
				//renommer
				query("UPDATE utilisateurs SET login='$login_esc' WHERE id_uti=$id_uti",$h);
				$info.="L'identifiant de connexion '$login_lu' a t chang en '$login'. ";
				$login_lu=$login;
				if (!empty($sso_login) && $sso_login_lu!=$sso_login) {
					$nb=queryValue("SELECT COUNT(*) FROM utilisateurs WHERE sso_login LIKE '$sso_login_esc' AND id_uti<>$id_uti",$h);
					if (!$nb) query("UPDATE utilisateurs SET sso_login='$sso_login_esc' WHERE id_uti=$id_uti",$h);
					else $info.="L'identifiant SSO '$sso_login' n'a pas t enregistr car il appartient  un autre utilisateur. ";
					
				}
			}
			else {
				if ($refuser_reutilisation) {
					$erreur.="Erreur: il existe dj un identifiant de connexion '$login'.";
					return 0;
				}
				else {
					if ($use_sso) 
						if ($sso_login)
							$info.="Le compte dj existant '$login' a t utilis - pour se connecter, l'utilisateur doit utiliser l'identifiant SSO '$sso_login_nouv' du compte '$login', dans le portail $sso_portail.";
						else 
							$info.="Le compte dj existant '$login' a t utilis - pour se connecter, l'utilisateur doit utiliser le compte '$login' dans le portail $sso_portail.";
							
					else $info.="Le compte dj existant '$login' a t utilis - pour se connecter, l'utilisateur doit maintenant renseigner le mot de passe du compte '$login'.";
					return $id_uti_nouv;
				}
			}			
		}		
		// rinitialise le mdp ?
		if ($mdp && ($codage!=$codage_lu || strcmp($mdp,$mdp_lu))) {
			$mdp=myEscapeString($h,$mdp);			
			query("UPDATE utilisateurs SET mdp='$mdp', codage='$codage' WHERE id_uti=$id_uti",$h);
			if (!$erreur) $info.="Le mot de passe du compte '$login_lu' a t initialis. ";
		}
		// changer sso_login ?
		if ($sso_login && $sso_login!=$sso_login_lu) {
			$nb=queryValue("SELECT COUNT(*) FROM utilisateurs WHERE sso_login LIKE '$sso_login_esc' AND id_uti<>$id_uti",$h);
			if (!$nb) query("UPDATE utilisateurs SET sso_login='$sso_login_esc' WHERE id_uti=$id_uti",$h);
			else $info.="L'identifiant SSO '$sso_login' n'a pas t enregistr car il appartient un autre utilisateur. ";
		}
		// effacer sso login ?
		if (!$sso_login && $sso_login_lu) {
			query("UPDATE utilisateurs SET sso_login=NULL WHERE id_uti=$id_uti",$h);
		}
	}
	return $id_uti;
}

function verifiermotDePasse($mdp,$mdp_base,$codage,$h)
{
	global $erreur, $cle_aes;
	$resultat=false;
	if ($codage==1) 
		$resultat=$mdp_base==md5($mdp);
	else if ($codage==2)  { //AES
		if ($cle_aes=='') {
			$erreur="L'administrateur n'a pas dfini de cl AES. L'inscription est impossible. Prvenez l'administrateur.";
			return false;
		}
		$resultat=$mdp_base==queryValue("SELECT AES_ENCRYPT('$mdp', '$cle_aes')",$h);
	}
	else $resultat=$mdp_base==$mdp;
	return $resultat;
}

function orphelin($id_uti,$h)
{
	$n=queryValue("SELECT COUNT(*) FROM stagiaires WHERE id_uti=$id_uti",$h);
	if ($n) return false;
	$n=queryValue("SELECT COUNT(*) FROM intervenants WHERE id_uti=$id_uti",$h);
	if ($n) return false;
	$n=queryValue("SELECT COUNT(*) FROM administrateurs WHERE id_uti=$id_uti",$h);
	return $n==0;
}
// retourne un login gnrique unique pour un utilisateur donn 
function loginGeneriqueUnique($id_uti,$h)
{
	$unuti='utilisateur'.$id_uti;
	$nb=queryValue("SELECT COUNT(*) FROM utilisateurs WHERE id_uti<>$id_uti AND login LIKE '$unuti'",$h);
	if ($nb==0) return $unuti;
	$n=9;
	do {
		++$n;
		$unuti='utilisateur'.strtoupper(base_convert($n,10,36)).$id_uti;
		$nb=queryValue("SELECT COUNT(*) FROM utilisateurs WHERE id_uti<>$id_uti AND login LIKE '$unuti'",$h);
		if ($nb>0) {
			++$n;
			$unuti='utilisateur'.strtoupper(base_convert($n,10,36)).$id_uti;
		}
	} while ($nb>0);	
	return $unuti;
}

function nbConnexions($id_uti,$h)
{
	$n=queryValue("SELECT COUNT(*) FROM stagiaires WHERE id_uti=$id_uti",$h);
	$n+=queryValue("SELECT COUNT(*) FROM intervenants WHERE id_uti=$id_uti",$h);
	$n+=queryValue("SELECT COUNT(*) FROM administrateurs WHERE id_uti=$id_uti",$h);
	return $n;
	
}
/*
	TesteMd5
	Teste un mot de passe crypt en md5: vrifie validit de la chane
*/
function testeMd5($md5)
{
	return strlen($md5)==32? testeHex($md5):false;
}

function testeHex($hex)
{
	$ok=true;
	$L=strlen($hex);
	for ($i=0; $ok && $i<$L;++$i) {
		$c=substr($hex,$i,1);
		$ok=(($c>='a' && $c<='f') || ($c>='A' && $c<='F') || ($c>='0' && $c<='9')); 
	}
	return $ok;
}
/*
	hex2bin n'existe pas sur les versions PHP < 5.4
*/

if (!function_exists('hex2bin')) {

function hex2bin($hex)
{
	$len = strlen($hex);
	if ($len%1) $hex='0'.$hex;//ce test ne devrait pas arriver, hex2bin n'est utilis que pour restaurer des sauvegardes...
	$bin='';
	for($i=0;$i<$len;$i+=2) 
		$bin.=chr(hexdec(substr($hex, $i,2)));
		
	return $bin; 	
}
}

/*
	ControleMdp: contrle du mot de passe lors de l'importation d'utilisateurs
	Le mot de passe entr est contrl et au besoin modifi s'il est incorrect. 
*/
function controleMdp(&$mdp, &$codage)
{
	global $use_sso;
	$c_mdp='';
	if ($mdp>=0) {
		$c_mdp=str_replace('"','',strval(trim($mdp)));
		switch ($codage)
		{
			case 0: 
				if (!motDePasse($c_mdp)) $c_mdp='';
			break;
			case 1:
				if (!testeMd5($c_mdp)) 	$c_mdp='';
			break;
			case 2: 
				if (testeHex($mdp)) $c_mdp=hex2bin($c_mdp);
			break;
		}
	}
	// mot de passe plus fort que les prcdentes versions
	// Nous abandonnons le codage JJMM du mot de passe  partir de la date de naissance !
	if (strlen($c_mdp)==0) {
		$c_mdp=getMdp();
		$codage=0;
	}
	$mdp=$c_mdp;
}
// Gnre une chaine de nombres hexadeximaux, alatoire

function semence()
{
	$out='';
	for ($i=0;$i<32;++$i) {
		$x=rand(0,15);
		if ($x>=10) $x+=55;
		else $x+=48;
		$out.=chr($x);
	}
	return $out;
}
function getMdp($L=8)
{
	$t='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ01234567890123456789';
	$out='';
	$l=strlen($t);
	for ($i=0;$i<$L;++$i) {
		$x=rand(0,$l-1);
		$out.=substr($t,$x,1);
	}
	return $out;	
}
function decodeXor($mdp_hex, $semence)
{
	$l1=strlen($semence);
	$l2=strlen($mdp_hex);
	if ($l2%2) $$mdp_hex.='0';
	if ($l1%2) $semence.='0';
	$i=0;
	$j=0;
	$out='';
	for ($i=0;$i<$l2;++$i) {
		$c1=ord($mdp_hex[$i]);
		if ($c1>=65) $c1-=55;
		else $c1-=48;
		if ($c1<0||$c1>=16) return '';
		$d1=ord($semence[$j]);
		if ($d1>=65) $d1-=55;
		else $d1-=48;
		++$i;
		++$j;		
		$c2=ord($mdp_hex[$i]);
		if ($c2>=65) $c2-=55;
		else $c2-=48;
		if ($c2<0||$c2>=16) return '';
		$d2=ord($semence[$j]);
		if ($d2>=65) $d2-=55;
		else $d2-=48;
		$c=$c1*16+$c2;
		$d=$d1*16+$d2;
		$o=$c^$d;
		if ($o) $out.=chr($o);
		if (++$j>=$l1) $j=0;
	}
	
	return $out;
}

// encode=true: encoder: passer du login en clair vers le login encod
// encode=false: dcoder: passer du login encod au login en clair
function encodeCookieLogin($in,$encode)
{
	if ($encode) {
		$s1='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789@-._';
		$s2='fYikhqgsjbCUnDvGSAcB-d@l.LmH4ruozwV2Ra1NK9e6tW7Ty5pMOxJIXP3EZ_F0Q8';
	}
	else {
		$s1='fYikhqgsjbCUnDvGSAcB-d@l.LmH4ruozwV2Ra1NK9e6tW7Ty5pMOxJIXP3EZ_F0Q8';
		$s2='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789@-._';
	}
	$l=strlen($in);
	$out='';
	for ($i=$l-1;$i>=0;--$i) {
		$p=strpos($s1,$in[$i]);
		if ($p===false) 
			$out.=$in[$i];
		else
			$out.=$s2[$p];
	}
	return $out;
}
function sso_connect($h,$ferme,$sso_login,$sso_usermail)
{
	$id_uti=0;
	global $erreur;
	global $sso_bloque_interface;
	if ($sso_login) {
		$r=query("SELECT id_uti,login FROM utilisateurs WHERE sso_login LIKE '$sso_login'",$h);
		if ($r) {
			$row=@mysqli_fetch_row($r);
			if ($row) {
				$id_uti=$row[0];
				$login=strtolower($row[1]);
			}
		}
		if ($id_uti) {
			if ($ferme) {
				$id_admin=queryValue("SELECT id_admin FROM administrateurs WHERE id_uti=$id_uti AND type_admin=1",$h);
				if (!$id_admin) {
					header('Location: site_ferme.php');
					exit;
				}
				$_SESSION['circonscript7_administration']=$id_admin;
			}
			$_SESSION['circonscript7_id_uti']=$id_uti;
			$_SESSION['circonscript7_sso']=1;
			enregistreAcces($id_uti,$h,4);// 4 SSO, login
			if ($sso_usermail=='') {
				header('Location: compte.php');
				exit;
			}
			else 
				if ($sso_usermail==$login){
					header('Location: compte.php');
					exit;
				}
				else {
					header('Location: sso_info_login.php');// faire des mofications et prvenir 
					exit;
				}
			
		}
	}
	if ($sso_usermail) {
		$id_uti=queryValue("SELECT id_uti FROM utilisateurs WHERE login LIKE '$sso_usermail'",$h);
		if ($id_uti) {
			if ($ferme) {
				$id_admin=queryValue("SELECT id_admin FROM administrateurs WHERE id_uti=$id_uti AND type_admin=1",$h);
				if (!$id_admin) {
					header('Location: site_ferme.php');
					exit;
				}
				$_SESSION['circonscript7_administration']=$id_admin;
			}
			if ($sso_login) query("UPDATE utilisateurs SET sso_login='$sso_login' WHERE id_uti=$id_uti AND (sso_login<>'$sso_login' OR sso_login IS NULL)",$h);// NB si sso_login existe dj ailleurs dans la base il n'y aura pas d'update.
			enregistreAcces($id_uti,$h,5);// SSO, usermail
			$_SESSION['circonscript7_id_uti']=$id_uti;
			$_SESSION['circonscript7_sso']=1;
			
			header('Location: compte.php');
			exit;
		}
	}
	if(!empty($sso_usermail) || !empty($sso_login)) {
		header('Location: erreur.php?erreur=sso_connexion');
		exit;
	}	
}
?>