<?php
/*	
	Requetes Test de l'intgrit de la base
	Circon'script PHP Script
	Version 7.0.3 
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/
	$req=array(
//---------------coles, stagiaires
		"coles sans circo" =>array(
		"SELECT ecoles.id_ecole, circos.id_circo
		FROM ecoles
		LEFT JOIN circos ON circos.id_circo=ecoles.id_circo
		HAVING id_circo IS NULL"),

		"stagiaires sans cole" =>array(
		"SELECT stagiaires.id_stagiaire, ecoles.id_ecole
		FROM stagiaires
		LEFT JOIN ecoles ON ecoles.id_ecole=stagiaires.id_ecole
		HAVING id_ecole IS NULL"),
		
		"stagiaires dans un groupe inexistant" =>array(
		"SELECT stagiaires.id_stagiaire, groupes.id_groupe
		FROM stagiaires
		LEFT JOIN groupes ON groupes.id_groupe=stagiaires.id_groupe
		WHERE stagiaires.id_groupe>0
		HAVING id_groupe IS NULL",
		"UPDATE stagiaires SET id_groupe=0 WHERE id_stagiaire=%d"
		),
//----------------------Utilisateurs
		"stagiaires sans utilisateurs" =>array(
		"SELECT stagiaires.id_stagiaire,utilisateurs.id_uti FROM stagiaires
		LEFT JOIN utilisateurs ON stagiaires.id_uti=utilisateurs.id_uti
		HAVING utilisateurs.id_uti IS NULL","*0"),

		"intervenants sans utilisateurs" =>array(
		"SELECT intervenants.id_intervenant,utilisateurs.id_uti FROM intervenants
		LEFT JOIN utilisateurs ON intervenants.id_uti=utilisateurs.id_uti
		HAVING utilisateurs.id_uti IS NULL","*1"),

		"administrateurs sans utilisateurs" =>array(
		"SELECT administrateurs.id_admin,utilisateurs.id_uti FROM administrateurs
		LEFT JOIN utilisateurs ON administrateurs.id_uti=utilisateurs.id_uti
		HAVING utilisateurs.id_uti IS NULL","*2"),
		
		"utilisateurs ayant le mme login" =>array(
		"SELECT utilisateurs.id_uti,u2.id_uti FROM utilisateurs , utilisateurs u2
		WHERE utilisateurs.id_uti<u2.id_uti AND utilisateurs.login=u2.login","*3"),
		
		
// ----------------animations

		"domaines sans circo" =>array(
		"SELECT domaines.id_domaine, circos.id_circo
		FROM domaines
		LEFT JOIN circos ON circos.id_circo=domaines.id_circo
		HAVING circos.id_circo IS NULL"),

		"thmes sans circo" =>array(
		"SELECT themes.id_theme, circos.id_circo
		FROM themes
		LEFT JOIN circos ON circos.id_circo=themes.id_circo
		HAVING circos.id_circo IS NULL"),
		
		"circos favorites (table bassin) n'appartenant pas  une circo"=>array(
		"SELECT bassin.id_bassin,circos.id_circo FROM bassin
		LEFT JOIN circos ON bassin.id_circo=circos.id_circo
		HAVING id_circo IS NULL"),

		"circos favorites (table bassin) rfrenant une circo disparue"=>array(
		"SELECT bassin.id_bassin,circos.id_circo FROM bassin
		LEFT JOIN circos ON bassin.id_circo_bassin=circos.id_circo
		HAVING id_circo IS NULL"),

		"animations sans circo" =>array(
		"SELECT animations.id_anim,circos.id_circo FROM animations
		LEFT JOIN circos ON animations.id_circo=circos.id_circo
		HAVING id_circo IS NULL"),

		"animations sans position" =>array(
		"SELECT animations.id_anim,positions.id_position FROM animations
		LEFT JOIN positions ON positions.id_anim=animations.id_anim
		HAVING id_position IS NULL"),

		"animations sans position dans la circo d'appartenance" =>array(
		"SELECT animations.id_anim, po.id_position FROM animations
		LEFT JOIN (SELECT positions.id_position, positions.id_anim, domaines.id_circo FROM positions, domaines WHERE positions.id_domaine = domaines.id_domaine)  AS po ON po.id_anim = animations.id_anim AND po.id_circo = animations.id_circo HAVING po.id_position IS NULL"),
		
		"animations avec plusieurs positions dans la mme circo" =>array(
		"SELECT positions.id_position 
		FROM positions, positions AS p2, domaines as d1, domaines as d2
		WHERE positions.id_position>p2.id_position
		AND positions.id_anim=p2.id_anim AND positions.id_domaine=d1.id_domaine AND p2.id_domaine=d2.id_domaine AND d1.id_circo=d2.id_circo
		GROUP BY positions.id_position"),

		"animations avec une catgorie inexistante" =>array(
		"SELECT animations.id_anim, categories.id_categorie as cat FROM animations
		LEFT JOIN categories ON categories.id_categorie=animations.id_categorie
		WHERE animations.id_categorie!=0
		HAVING cat IS NULL",
		"UPDATE animations SET id_categorie=0 WHERE id_anim=%d"),
		
		"positions sans domaine" =>array(
		"SELECT positions.id_position,domaines.id_domaine FROM positions
		LEFT JOIN domaines ON positions.id_domaine=domaines.id_domaine
		HAVING id_domaine IS NULL"),
		
		"positions sans thme" =>array(
		"SELECT positions.id_position,themes.id_theme FROM positions
		LEFT JOIN themes ON positions.id_theme=themes.id_theme
		HAVING id_theme IS NULL"),
		
		"positions sans animations" =>array(
		"SELECT positions.id_position,animations.id_anim FROM positions
		LEFT JOIN animations ON positions.id_anim=animations.id_anim
		HAVING id_anim IS NULL"),
		 
		"positions dont le domaine et le thme n'appartiennent pas  la mme circo" =>array(
		"SELECT positions.id_position FROM positions,domaines,themes
		WHERE domaines.id_domaine=positions.id_domaine AND themes.id_theme=positions.id_theme AND domaines.id_circo<>themes.id_circo"),
		
 		"positions dont le domaine et le thme n'appartiennent pas  la mme anne" =>array(
		"SELECT positions.id_position FROM positions,domaines,themes
		WHERE domaines.id_domaine=positions.id_domaine AND themes.id_theme=positions.id_theme AND domaines.annee<>themes.annee"),
		
		"sances sans animation" =>array(
		"SELECT seances.id_seance, animations.id_anim
		FROM seances
		LEFT JOIN animations ON seances.id_anim=animations.id_anim
		HAVING id_anim IS NULL"),

		"animations sans sances"=>array(
		"SELECT animations.id_anim, seances.id_seance
		FROM animations
		LEFT JOIN seances ON seances.id_anim=animations.id_anim
		HAVING id_seance IS NULL"),

		"dates sans sance" =>array(
		"SELECT dates.id_date, seances.id_seance
		FROM dates
		LEFT JOIN seances ON dates.id_seance=seances.id_seance
		HAVING id_seance IS NULL"),

		"sances sans date" =>array(
		"SELECT seances.id_seance, dates.id_date
		FROM seances
		LEFT JOIN dates ON dates.id_seance=seances.id_seance
		HAVING id_date IS NULL"),

		"partages sans circo" =>array(
		"SELECT partages.id_partage, circos.id_circo FROM partages
		LEFT JOIN circos ON circos.id_circo=partages.id_circo
		HAVING id_circo IS NULL"),
		
		"partages sans sance" =>array(
		"SELECT partages.id_partage, seances.id_seance FROM partages
		LEFT JOIN seances ON seances.id_seance=partages.id_seance
		HAVING id_seance IS NULL"),
		
		"partages accepts sans position dans la circo" =>array(
		"SELECT partages.id_partage, po.id_circo FROM partages
		INNER JOIN seances ON partages.id_seance = seances.id_seance
		LEFT JOIN (SELECT positions.id_position, positions.id_anim, domaines.id_circo
		FROM positions, domaines
		WHERE positions.id_domaine = domaines.id_domaine) AS po ON po.id_circo = partages.id_circo AND po.id_anim = seances.id_anim
		WHERE partages.accepte <>0
		HAVING po.id_circo IS NULL","*4"),
		
		"partages en plusieurs exemplaires" =>array(
		"SELECT partages.id_partage FROM partages, partages as p2
		WHERE partages.id_partage > p2.id_partage AND partages.id_seance=p2.id_seance AND partages.id_circo=p2.id_circo
		GROUP BY partages.id_partage"),
		
		"inscriptions sans stagiaires" =>array(
		"SELECT inscriptions.id_inscr, stagiaires.id_stagiaire FROM inscriptions
		LEFT JOIN stagiaires ON stagiaires.id_stagiaire=inscriptions.id_stagiaire
		HAVING id_stagiaire IS NULL"),
		
		"inscriptions sans sances" =>array(
		"SELECT inscriptions.id_inscr, seances.id_seance FROM inscriptions
		LEFT JOIN seances ON seances.id_seance=inscriptions.id_seance
		HAVING id_seance IS NULL"),

		"inscriptions en double" =>array(
		"SELECT inscriptions.id_inscr FROM inscriptions, inscriptions as c2
		WHERE inscriptions.id_inscr>c2.id_inscr AND inscriptions.id_seance=c2.id_seance AND inscriptions.id_stagiaire=c2.id_stagiaire GROUP BY inscriptions.id_inscr"), 
		
		"convocations sans stagiaires" =>array(
		"SELECT convocations.id_convoc, stagiaires.id_stagiaire FROM convocations
		LEFT JOIN stagiaires ON stagiaires.id_stagiaire=convocations.id_stagiaire
		HAVING id_stagiaire IS NULL"),

		"convocations sans sances" =>array(
		"SELECT convocations.id_convoc, seances.id_seance FROM convocations
		LEFT JOIN seances ON seances.id_seance=convocations.id_seance
		HAVING id_seance IS NULL"),

		"convocations en double" =>array(
		"SELECT convocations.id_convoc FROM convocations, convocations as c2
		WHERE convocations.id_convoc>c2.id_convoc AND convocations.id_seance=c2.id_seance AND convocations.id_stagiaire=c2.id_stagiaire GROUP BY convocations.id_convoc"), 
	
		"absences sans date" =>array(
		"SELECT absences.id_abs, dates.id_date FROM absences
		LEFT JOIN dates ON dates.id_date=absences.id_date
		HAVING id_date IS NULL"),
		
		"absences sans stagiaire" =>array(
		"SELECT absences.id_abs, stagiaires.id_stagiaire FROM absences
		LEFT JOIN stagiaires ON stagiaires.id_stagiaire=absences.id_stagiaire
		HAVING id_stagiaire IS NULL"),

		"absences en double" =>array(
		"SELECT absences.id_abs FROM absences, absences as c2
		WHERE absences.id_abs>c2.id_abs AND absences.id_date=c2.id_date AND absences.id_stagiaire=c2.id_stagiaire GROUP BY absences.id_abs"), 
		
		"absences sans convocation" =>array(
		// un stagiaire absent doit tre convoqu  la sance pour laquelle il est absent
		"SELECT absences.id_abs, convocations.id_convoc FROM absences
		INNER JOIN dates ON absences.id_date=dates.id_date
		LEFT JOIN convocations ON convocations.id_stagiaire=absences.id_stagiaire AND convocations.id_seance=dates.id_seance
		HAVING convocations.id_convoc IS NULL"),
	
		"rgles sans circo" =>array(
		"SELECT regles.id_regle, circos.id_circo FROM regles
		LEFT JOIN circos ON circos.id_circo=regles.id_circo
		HAVING id_circo IS NULL"),

		"rgles avec une cole inexistante" =>array(
		"SELECT regles.id_regle, regles.id_ecole, ecoles.id_ecole as ec2 FROM regles
		LEFT JOIN ecoles ON ecoles.id_ecole=regles.id_ecole
		HAVING id_ecole >0 AND ec2 IS NULL"),
		
		"rgles avec un groupe inexistant" =>array(
		"SELECT regles.id_regle, groupes.id_groupe AS g FROM regles
		LEFT JOIN groupes ON groupes.id_groupe=regles.id_groupe
		WHERE regles.id_groupe>0
		HAVING g IS NULL"),

		"intervenants dans une circo inexistante"=>array(
		"SELECT intervenants.id_intervenant, circos.id_circo FROM intervenants
		LEFT JOIN circos ON circos.id_circo=intervenants.id_circo
		WHERE intervenants.id_circo>0
		HAVING id_circo IS NULL",
		"UPDATE intervenants SET id_circo=0 WHERE id_intervenant=%d"
		),
		"interventions sans intervenant" =>array(
		"SELECT interventions.id_intervention, intervenants.id_intervenant FROM interventions 
		LEFT JOIN intervenants ON interventions.id_intervenant=intervenants.id_intervenant
		HAVING intervenants.id_intervenant IS NULL"),

		"interventions sans date" =>array(
		"SELECT interventions.id_intervention, dates.id_date FROM interventions 
		LEFT JOIN dates ON interventions.id_date=dates.id_date
		HAVING dates.id_date IS NULL"),
		
//------------Groupes
		"groupes sans circo" =>array(
		"SELECT groupes.id_groupe,circos.id_circo FROM groupes 
		LEFT JOIN circos ON circos.id_circo=groupes.id_circo
		HAVING circos.id_circo IS NULL"),

		"groupements sans groupes" =>array(
		"SELECT groupements.id_groupement,groupes.id_groupe FROM groupements
		LEFT JOIN groupes ON groupes.id_groupe=groupements.id_groupe
		HAVING groupes.id_groupe IS NULL"),

		"groupements sans sances" =>array(
		"SELECT groupements.id_groupement,seances.id_seance FROM groupements
		LEFT JOIN seances ON seances.id_seance=groupements.id_seance
		HAVING seances.id_seance IS NULL"),

//------------------Droits et administrateurs de circos multiples
		"droits sans administrateurs" =>array(
		"SELECT droits.id_droit,administrateurs.id_admin FROM droits
		LEFT JOIN administrateurs ON administrateurs.id_admin=droits.id_admin
		HAVING administrateurs.id_admin IS NULL"),

		"droits sans circos" =>array(
		"SELECT droits.id_droit,circos.id_circo FROM droits
		LEFT JOIN circos ON circos.id_circo=droits.id_circo
		HAVING circos.id_circo IS NULL"),

//------------------listes
		"listes sans circos" =>array(
		"SELECT listes.id_liste, circos.id_circo FROM listes
		LEFT JOIN circos ON circos.id_circo=listes.id_circo
		HAVING circos.id_circo IS NULL"),

		"items sans listes" =>array(
		"SELECT items.id_item, listes.id_liste FROM items
		LEFT JOIN listes ON listes.id_liste=items.id_liste
		HAVING listes.id_liste IS NULL"),

		"items sans sances" =>array(
		"SELECT items.id_item, seances.id_seance FROM items
		LEFT JOIN seances ON seances.id_seance=items.id_seance
		HAVING seances.id_seance IS NULL")

	);
?>		
