<?php
/* 
	Routines de sauvegarde 
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/

$tables=array('absences','administrateurs','animations','bassin','circos','convocations','dates','domaines','droits','ecoles','general','groupements','groupes','inscriptions','intervenants','interventions','niveaux','partages','positions','quotites','regles','seances','stagiaires','themes','utilisateurs','listes','items','categories','suffixes');
$nulsSiVides=array('circos'=>array('dt_ouverture','dt_fermeture'),'utilisateurs'=>array('dt_connexion','sso_login'),'intervenants'=>array('ical_session'));
// champ $nulsivides conserv pour compatibilit des versions prcdentes -> 7.0. Maintenant, la gestion de la valeur null est correcte et diffrente de la chane vide.
$nulifier=array('intervenants'=>array('ical_timestamp','ical_cache'));
// ne pas sauvegarder ces lments; peuvent tre automatiquement reconstruits
$version="Circonscript 7";// pour la sauvegarde. 
$versions_lues=array($version,"Circonscript 6");// pour la restauration, on peut lire aussi les fichiers de la v6

function sauvegarder()
{
	global $erreur,$cle,$tables,$version;
	$h=connect();
	$d=getdate();
	$nomfich=sprintf("svg/%04d-%02d-%02d_%02d%02d%02d.svg",$d['year'],$d['mon'],$d['mday'],$d['hours'],$d['minutes'],$d['seconds']);
	$tempfich=tempnam('./svg/','tmp');
	$fp=fopen($tempfich,'w');
	if (!$fp) {
		$erreur="Impossible de crer le fichier temporaire: $nomfich";
		return'';
	}
	$q='';
	foreach($tables as $table) 
		if (!$q) $q.="LOCK TABLES $table READ LOCAL";		
		else $q.=", $table READ LOCAL";
	$q.=', tmp_absences READ LOCAL'; 		
	$r=query($q,$h);
	if ($erreur) {
		fclose($fp);
		unlink ($tempfich);
		return'';
	}
	@set_time_limit(0); // pas de limitation pour le calcul, qui peut tre long...
	// sauve le md5 de la cl
	if ($cle)
		$cle1=md5($cle);
	else
		$cle1=md5('Circonscript');
	fputs($fp,"$cle1\n");
	fputs($fp,"$version\n"); // nouveaut V4
	foreach($tables as $t) sauve($t,$h,$fp);
	query("UNLOCK TABLES",$h);
	fclose($fp);
	query("UPDATE general SET date_svg=NOW()",$h);
	if (!$erreur) {
			if ($cle) {
				encrypt($tempfich,$nomfich);
				unlink($tempfich);
			}
			else {
				rename($tempfich,$nomfich);
			}
			// Supprime les fichiers en trop
			$d= dir('svg/');
			$liste=array();
			while ($fich=$d->read()) {
				if ($fich=='.' || $fich=='..' || strpos($fich,".svg")==0) continue;
				$liste[]= $fich;
			}
			$d->close();
			rsort($liste);	
			for ($i=30;$i<count($liste);++$i) {
					if ($nomfich!=$liste[$i]) unlink ("svg/".$liste[$i]);//le test est ncessaire au cas o l'horloge a t perturbe...
			}
			if (!$erreur)
				return $nomfich;
			else 
				return '';
	}
	else {
		unlink ($nomfich);
		return '';
	}

}	

function sauve($table,$h,$fp)
{
	global $erreur,$nulifier;
	if ($erreur) return;
	fputs($fp,"\"$table\"\n");
	$r=query("SELECT * FROM $table",$h);
	// Sauve les noms des champs
	$deb=0;
	$mdp=-1;
	$c=0;
	$indexNuls=array();
	while ($f=@mysqli_fetch_field($r)) {
		$w=$f->name;
		if (!$deb) {
			fputs($fp,"\"$w\"");
			$deb=1;
		}
		else fputs($fp,";\"$w\"");
		if ($w=='mdp') $mdp=$c;
		if (isset($nulifier[$table]) && in_array($w,$nulifier[$table])) $indexNuls[]=$c;
		++$c;
	}
	fputs($fp,"\n");
	// sauve les donnes
	while ($row=@mysqli_fetch_row($r)) { 
		$deb=0;
		$c=0;
		foreach($row as $v) {
			if ($mdp==$c) 
				$w=bin2hex($v);
			else  {
				if (in_array($c,$indexNuls)) $w='null';
				else 
					if (!is_null($v)) $w="\"".myEscapeString($h,$v)."\"";
					else $w="null";
			}
			if (!$deb) {
				fputs($fp,"$w");
				$deb=1;
			}
			else fputs($fp,";$w");
			++$c;
		}
		fputs($fp,"\n");
	}
	fputs($fp,"#\n");
}


function restaurer($nomfich)
{
	global $erreur,$cle,$tables,$versions_lues;
	$fich="svg/".$nomfich;
	$tempfich='';
	if ($cle) {
		$tempfich=tempnam('./svg/','tmp');
		//$tempfich='./svg/'.$tempfich;

		encrypt($fich,$tempfich);
		if ($erreur) return;
		$fp=fopen($tempfich,"r");
		if (!$fp) { 
			$erreur="Impossible d'ouvrir le fichier temporaire '$tempfich'";
			return;
		}
	}
	else {
		$fp=fopen("svg/$nomfich","r");
		if (!$fp) { 
			$erreur="Impossible d'ouvrir le fichier '$nomfich'";
			return;
		}
	
	}
	$h=connect();

	// sauvegarde de l'admin courant
	$id_uti=$_SESSION['circonscript7_id_uti'];
	$r=query("SELECT login, mdp,codage FROM utilisateurs WHERE id_uti=$id_uti",$h);
	if (!$r) {
		header("Location: erreur.php?erreur=utilisateur");
		exit;
	}
	$row=@mysqli_fetch_row($r);
	if (!isset($row) || empty($row)) {
		header("Location: erreur.php?erreur=utilisateur");
		exit;
	}
	$login=myEscapeString($h,$row[0]);
	$mdp=myEscapeString($h,$row[1]);
	$codage=$row[2];
	$r=query("SElECT nom,courriel FROM administrateurs WHERE id_uti=$id_uti",$h);
	if (!$r) {
		header("Location: erreur.php?erreur=admin");
		exit;
	}
	$row=@mysqli_fetch_row($r);
	$nom=myEscapeString($h,$row[0]);
	$courriel=myEscapeString($h,$row[1]);
	$q='';
	foreach($tables as $table) 
		if (!$q) $q.="LOCK TABLES $table WRITE";		
		else $q.=", $table WRITE";
	$q.=', tmp_absences WRITE, acces WRITE';
	$r=query($q,$h);
	if ($erreur) {
		query("UNLOCK TABLES",$h);
		fclose($fp);
		if ($tempfich) unlink($tempfich);
		return;
	}
	@set_time_limit(0); // pas de limitation pour la restauration, qui peut tre long...
	if ($cle)
		$cle1=md5($cle);
	else
		$cle1=md5('Circonscript');
	$cle_in=fgetcsv($fp,100);
	if (!isset($cle_in) || count($cle_in)!=1 || $cle_in[0]!=$cle1) {
		query("UNLOCK TABLES",$h);
		$erreur="Cl de cryptage incorrecte. Restauration non effectue.";
		fclose($fp);
		if ($tempfich) unlink($tempfich);
		return;
	}
	$version=fgetcsv($fp,100);
	if ( !isset($version) || count($version)!=1 || !in_array($version[0],$versions_lues)) {
		query("UNLOCK TABLES",$h);
		$erreur="Erreur de version de Circonscript. Restauration annule.";
		fclose($fp);
		if ($tempfich) unlink($tempfich);
		return;
	}
	while (!$erreur ) {
		$table=fgetcsv($fp,100);
		if ($table===FALSE || count($table)!=1 || $table[0]=='') break;
		if (!in_array($table[0],$tables)) {
			//$erreur.=sprintf("La table '%s' du fichier de sauvegarde n'existe pas. ",$table[0]);
			// ne pas tenir compte d'une table qui ne doit pas tre dans le fichier (prcdente version possible)
			restaure($table[0],$h,$fp,true); // skip de la table
		}
		else restaure($table[0],$h,$fp);
	}
	if (!$erreur) {
		query("DELETE FROM acces",$h);
		query("ALTER TABLE acces auto_increment=1",$h);
		query("DELETE FROM tmp_absences",$h);
		query("ALTER TABLE tmp_absences auto_increment=1",$h);
	}
	query("UNLOCK TABLES",$h);
	fclose($fp);
	if (!$erreur) $erreur="Restauration effectue. ";
	if ($tempfich) unlink($tempfich);
	// Rcupration ou cration du compte admin courant
	$r=query("SELECT id_uti FROM utilisateurs WHERE login LIKE '$login'",$h);
	$msg='';
	if (@mysqli_num_rows($r)>0) {
		$row=@mysqli_fetch_row($r);
		$id_uti=$row[0];
		query("UPDATE utilisateurs SET mdp='$mdp', codage=$codage WHERE id_uti=$id_uti",$h);
		$msg="Votre compte 'utilisateur' de login='$login' est rutilis. votre mot de passe actuel conserv. ";
	}
	else {
		$r=query("INSERT INTO utilisateurs(login, mdp, codage) VALUES ('$login','$mdp','$codage')",$h);
		if (!$r) {
			header("Location: erreur.php?erreur=bdd");
			exit;
		}
		$id_uti=@mysqli_insert_id($h);
		$msg="Votre compte 'utilisateur' de login='$login' a t recr, avec votre mot de passe actuel. ";
		
	}
	
	$r=query("SELECT id_admin FROM administrateurs WHERE id_uti=$id_uti AND type_admin=1",$h);
	if (@mysqli_num_rows($r)==0) { // pas de superadmin associ  id_uti: le crer
		$r=query("INSERT INTO administrateurs(id_uti,nom, courriel, type_admin) VALUES ($id_uti,'$nom','$courriel',1)",$h);
		if (!$r) {
			header("Location: erreur.php?erreur=bdd");
			exit;
		}
		$id_admin=@mysqli_insert_id($h);			
		$msg.="Votre compte 'administrateur' ($nom) a t recr. ";
	}
	else {
		$row=@mysqli_fetch_row($r);
		$id_admin=$row[0];
	}
	$erreur.=$msg;
	query("UPDATE general SET ferme=1",$h);	
	foreach($_SESSION as $k=>$v) switch ($k) {
		case 'circonscript7_sso':
		continue;
		default:
			unset($_SESSION[$k]);	
	}
	$_SESSION['circonscript7_id_uti']=$id_uti;
	$_SESSION['circonscript7_id_admin']=$id_admin;
	$_SESSION['circonscript7_administration']=$id_admin;	
	
}
// Les champs du fichier qui ne sont pas / plus dans la base sont ignors.	
function restaure($table,$h,$fp, $skip=false)
{
	global $erreur,$nulsSiVides;
	if ($erreur) return;
	if (!$skip) {
		$q="DELETE FROM $table";
		query($q,$h);
		$q="ALTER TABLE $table auto_increment=1";
		query($q,$h);
	}
	$t=fgetcsv($fp,100000,";");
	//restaure le nom des champs
	$champs='';
	$mdp=-1;
	$date=-1;
	$indexNuls=array();
	$c=0;
	$tchamps=array();
	$r=query("SHOW COLUMNS FROM $table",$h);
	$champsTable=array();
	$indexIgnores=array();
	while ($row=@mysqli_fetch_row($r)) 
		$champsTable[]=strtolower($row[0]);
	if (!($t===FALSE)) {
		if (count($t)==0) {
			$erreur="Fichier corrompu";
			return;
		}
		if(count($t)==1 && $t[0]=='#'){
			$erreur="Fin de fichier prmature";
			return;
		}
		foreach($t as $v) {
			if (!in_array(strtolower($v),$champsTable)){
				$indexIgnores[]=$c;	
			}
			else {
				if (!empty($champs)) $champs.=",$v";
				else $champs="$v";
				if ($table=='utilisateurs' && $v=='mdp') $mdp=$c;
				else {
					if (isset($nulsSiVides[$table]) && in_array($v,$nulsSiVides[$table])) $indexNuls[]=$c;
					if ($v=='date'||$v=='date_publipostage'||$v=='date_publi_convoc')$date=$c;
				}
			}
			++$c;
		}
	}
	if ($champs=='') {
			$erreur="Dfinition des champs absente sur table [$table]. ";
			return;
	}
	//restaure les donnes.
	$t=fgetcsv($fp,100000,";");
	while (!($t===FALSE) &&!$erreur) {
		if (count($t)==0) {
			$erreur="Fichier corrompu";
			break;
		}
		if(count($t)==1 && $t[0]=='#') break;
		$w='';
		$c=0;
		foreach($t as $v) {
			if (!in_array($c,$indexIgnores)){
				if($v=='null' || (!$v && (in_array($c,$indexNuls)))) {
					if (!empty($w)) $w.=",null";
					else $w="null";
				}
				else {
					if ($c==$mdp) 
						$v=myEscapeString($h,hex2bin($v));
					if ($c==$date && $v=='0000-00-00')$v='9999-12-31';// viter les erreurs Mysql sur les dates "0000-00-00" des versions prcdentes
					if (!empty($w)) $w.=",'$v'";
					else $w="'$v'";
				}
			}
			++$c;
		}
		if (!$skip) {
			$q="INSERT INTO $table($champs) VALUES ($w)";
			query($q,$h);
		}
		$t=fgetcsv($fp,100000,";");
	}
}

function encrypt($FichIn,$FichOut)
{
	global $erreur,$cle;
	$cle1=md5($cle);
	$cle2='';
	for ($i=0;$i<16;++$i) {
		$cle1=md5($cle1);
		$cle2.=$cle1;
	}
	$hin=fopen($FichIn,'rb');
	if ($hin==NULL) {
		$erreur="Impossible d'ouvrir le fichier '$FichIn' en lecture";
		return false;
	}
	$hout=fopen($FichOut,'wb');
	if ($hout==NULL) {
		$erreur="Impossible d'ouvrir le fichier '$FichOut' en criture";
		return false;
	}
	$L=strlen($cle2);
	$in=fread($hin,$L);
	$nb=strlen($in);
	$j=0;
	while($nb>0) {
		$out='';
		for($i=0;$i<$nb;++$i) {
			$c=substr($in,$i,1)^substr($cle2,$j,1);		
			$out.=$c;
			if (++$j>=$L) $j=0;
		}
		fwrite($hout,$out);	
		$in=fread($hin,$L);
		$nb=strlen($in);
	}
	fclose($hout);
	fclose($hin);
	return true;
}
?>
