<?php
/* 
	Exportation des convocations et des inscriptions sous forme de csv pour l'administrateur
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/

	require('_session.php');
	if (!isset($_SESSION['circonscript7_administration'])) {
		header( 'Location: erreur.php?erreur=expiree');
		exit;
	}		
	if (isset($_GET['url_ret'])) {
		$url_ret_adm_adm_convocations_export=strip_tags($_GET['url_ret']);
		$_SESSION['circonscript7_url_ret_adm_adm_convocations_export']=$url_ret_adm_adm_convocations_export;
	}
	else if (isset($_SESSION['circonscript7_url_ret_adm_adm_convocations_export'])) {
		$url_ret_adm_adm_convocations_export=$_SESSION['circonscript7_url_ret_adm_adm_convocations_export'];
	}
	else $url_ret_adm_adm_convocations_export="adm_convocations.php";
	if (isset($_SESSION['circonscript7_adm_adm_convocation_export_foad'])) $foad=$_SESSION['circonscript7_adm_adm_convocation_export_foad'];
	else $foad=true;
	
	
	$erreur='';
	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	require '_fonctions_animation.inc.php';
	debugInit();
	$h=connect();
	$id_anim=0;
	if (isset($_SESSION['circonscript7_adm_adm_convocations_export_date_sql'])) 
		$adm_adm_convocations_export_date_sql=$_SESSION['circonscript7_adm_adm_convocations_export_date_sql'];
	else 
		$adm_adm_convocations_export_date_sql='';
	if (isset($_POST['export_inscr'])) {
		exporter($h,'inscriptions');
	
	}
	else 	if (isset($_POST['export_conv'])) {
		exporter($h,'convocations');
	}
 
function exporter($h,$convocations)
{
	global $erreur,$foad;
	$foad=$_SESSION['circonscript7_adm_adm_convocation_export_foad']=isset($_POST['chkFoad']);
	
	if (!isset($_POST['uneCirco'])) {
		$erreur="Il faut choisir au moins une circonscription.";
		return;
	}
	// vrification scurit
	$r=query("SELECT id_circo FROM circos",$h);
	$lesCircos=array();
	while ($row=@mysqli_fetch_row($r)) $lesCircos[]=$row[0];
	foreach($_POST['uneCirco'] as $id_circo) {
		if (!in_array($id_circo,$lesCircos)) {
			$erreur="id_circo inconnue. Abandon.";
			return;
		}
	}
	$circos=implode(',',$_POST['uneCirco']);
	if(!$circos) return;
	$q="SELECT animations.id_anim,seances.id_seance,dates.id_date,animations.intitule, categories.codage, dates.date as date_seance,dates.duree, dates.horaire, dates.lieu, stagiaires.nom, stagiaires.prenom, utilisateurs.login,utilisateurs.sso_login,stagiaires.niveau, ecoles.nom as ecole, circos.libelle_court as circo,animations.annule
	FROM (animations,seances,dates,stagiaires,utilisateurs, ecoles,$convocations,circos)
	LEFT JOIN categories ON categories.id_categorie=animations.id_categorie
	WHERE animations.id_circo IN ($circos)  
	AND circos.id_circo=animations.id_circo
	AND seances.id_anim=animations.id_anim
	AND dates.id_seance=seances.id_seance";
	if ($foad) $q.=" AND dates.date='9999-12-30'";
	$q.=" AND $convocations.id_seance=seances.id_seance
	AND $convocations.id_stagiaire=stagiaires.id_stagiaire
	AND stagiaires.id_ecole=ecoles.id_ecole
	AND stagiaires.id_uti=utilisateurs.id_uti
	ORDER BY circos.libelle ASC, animations.id_anim ASC, seances.id_seance ASC, date_seance ASC,stagiaires.nom ASC, stagiaires.prenom ASC";
	debug($q);
	$r=query($q,$h);
	while (!$erreur) {
		$file=tempnam('./temp',"csv");		
		if (!$file) {
			$erreur="Impossible de crer un nom de fichier temporaire.";
			break;
		}
		$fp=fopen($file,'w');
		if (!$fp) {
			$erreur="Impossible de crer un fichier temporaire.";
			break;
		}
		fputs($fp,"annule;id_anim;id_seance;id_date;animation;catgorie;date;dure;horaire;lieu;nom;prnom;identifiant;identifiant SSO;niveau;cole;circo\n");
		while ($row=@mysqli_fetch_array($r)) {
			if ($row['annule']) fputs($fp,'oui;');
			else fputs($fp,'non;');
			fputs($fp,$row['id_anim']);
			fputs($fp,";");
			fputs($fp,$row['id_seance']);
			fputs($fp,";");
			fputs($fp,$row['id_date']);
			fputs($fp,";");
			fputs($fp,'"'.str_replace('"','""',$row['intitule']).'";');
			fputs($fp,'"'.str_replace('"','""',$row['codage']).'";');
			fputs($fp,'"'.dateSQLEnSaisie($row['date_seance']).'";');
			fputs($fp,'"'.str_replace('.',',',$row['duree']).'";');
			if ($row['date_seance']!='9999-12-30')
				if ($row['horaire']!='00:00:00')
					$horaire='"'.substr($row['horaire'],0,5).'";';
				else
					$horaire='"";';
			else $horaire='"";'; 
			fputs($fp,$horaire);		
			fputs($fp,'"'.str_replace('"','""',$row['lieu']).'";');
			fputs($fp,'"'.$row['nom'].'";');
			fputs($fp,'"'.$row['prenom'].'";');
			$login=$row['login'];
			fputs($fp,'"'.$login.'";');
			if (isset($row['sso_login']))fputs($fp,'"'.$row['sso_login'].'";');
			else fputs($fp,'"";');
			fputs($fp,'"'.$row['niveau'].'";');
			fputs($fp,'"'.str_replace('"','""',$row['ecole']).'";');
			fputs($fp,'"'.$row['circo'].'";');
			fputs($fp,"\n");
		}		
		fclose($fp);
		exportFichier($file,$convocations."_");
		exit;
	}
	
} 
 
function afficherCircos($h)
{
	$r=query("SELECT id_circo, libelle, type_circo FROM circos ORDER BY type_circo ASC, libelle ASC",$h);
	$nb=@mysqli_num_rows($r);
	if (!$r || !$nb) return;
	$max_col=3;
	print "<input type=\"checkbox\" onclick=\"javascript:selectionneTous(this)\"/>S&eacute;lectionner toutes\n";
	print "<table>\n";
	$col=0;
	while ($enr=@mysqli_fetch_row($r)) {
		$id_circo=$enr[0];
		$libelle='';
		if ($enr[2]==1) $libelle='[Virtuelle] ';
		else if ($enr[2]==2) $libelle='[Transfert] ';
		$libelle.=htmlentities($enr[1],ENT_COMPAT,'ISO-8859-15');
		if ($col==0) print "<tr>\n";
		print "<td><input type=\"checkbox\" value=\"$id_circo\" name=\"uneCirco[]\"/>$libelle</td>\n";	
		if (++$col==$max_col) {
			print "</tr>\n";
			$col=0;
		}
	}
	if ($col) {
		for (;$col<$max_col;++$col) print "<td>&nbsp;</td>\n";
		print "</tr>\n";
	}
	print "</table>\n"; 
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-15" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
		<script type="text/javascript">
		function selectionneTous(chk)
		{
			var mesCircos=document.getElementsByName("uneCirco[]");
			for (var i=0; i < mesCircos.length; ++i) mesCircos[i].checked=chk.checked;
		}
		</script></head>
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_adm_convocations_export?>">retour</a></li>
	  				<li><a href="#bas">bas</a></li>
				</ul>
			</div>
		  <div id="corps">	 
			  <h1>Exportation des inscriptions ou des convocations au format csv pour utilisation dans d'autres logiciels (M@gist&egrave;re, Ga&iuml;a, etc.) </h1>
			  <p>Important: contrairement aux exportations des convocations et inscriptions que les circos peuvent faire (Circo, convocations, exporter les inscriptions ou les convocations...), ici, seules les animations <em>organis&eacute;es par les circos</em> sont prises en compte. Les animations <em>import&eacute;es</em> ne sont pas prises en compte. </p>
			  <p>Ceci garantit que chaque animation n'est affich&eacute;e qu'une seule fois. Pour obtenir la liste des stagiaires pour des animations import&eacute;es, il suffit de cocher la circo qui a organis&eacute; cette animation. Vous aurez la liste de tous les stagiaires inscrits ou convoqu&eacute;s &agrave; cette animation, qu'ils appartiennent &agrave; cette circo ou &agrave; d'autres circos.</p>
			  <p>Pour faciliter les traitements ult&eacute;rieurs, nous ajoutons l'id_anim, id_seance et id_date &agrave; chaque enregistrement. </p>
			  <p>Attention, le fichier peut devenir volumineux.  </p>
		    <form method="post" action="">
				    <?php if ($erreur) print "<p class=\"erreur\">$erreur</p>";
				  afficherCircos($h);
				  ?> 
				    <input name="chkFoad" type="checkbox" id="chkFoad" <?php if ($foad) print 'checked="checked"'?>/>
				    N'exporter que les t&eacute;l&eacute;formations.
				  
				  
			  <h2>Exportations...</h2>
			  <p>Patientez, le traitement peut &ecirc;tre long ! </p>
			  <h2>Exporter les inscriptions 
                                  <input name="export_inscr" type="submit" class="bouton_standard" id="export_inscr" value="Exporter!" />
			  </h2>
			  <h2>Exporter les convocations
                                  <input name="export_conv" type="submit" class="bouton_standard" id="export_conv" value="Exporter !" />
              </h2>
            </form>
          </div>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_adm_convocations_export?>">retour</a></li>
		  			<li><a href="#haut">haut</a></li>
				</ul>
			</div>
			<a name="bas" id="bas"></a>	
		</div>
	</body>
</html>