<?php
/* 
	Exportation des circos
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/
	require('_session.php');
	if (isset($_GET['url_ret'])) {
		$url_ret_adm_circos_export=strip_tags($_GET['url_ret']);
		$_SESSION['circonscript7_url_ret_adm_circos_export']=$url_ret_adm_circos_export;
	}
	else if (isset($_SESSION['circonscript7_url_ret_adm_circos_export'])) {
		$url_ret_adm_circos_export=$_SESSION['circonscript7_url_ret_adm_circos_export'];
	}
	else $url_ret_adm_circos_export="administration.php";
	if (!isset($_SESSION['circonscript7_administration'])) {
		header( 'Location: erreur.php?erreur=expiree');
		exit;
	}		
	
	$erreur='';
	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	$h=connect();
	debugInit();
	if (isset($_POST['Submit'])) {
		exporteCircosCSV($h);
	}
	
function exporteCircosCSV($h)
{
	global $erreur,$id_circo;
	
	while (!$erreur) {
		$file=tempnam("./temp","csv");
		if (!$file) {
			$erreur="Impossible de crer un nom de fichier temporaire.";
			break;
		}
		$fp=fopen($file,'w');
		if (!$fp) {
			$erreur="Impossible de crer un fichier temporaire.";
			break;
		}
		fputs($fp,'"RNE";"LIBELLE";"LIBELLE_COURT";"TYPE_CIRCO";"COURRIEL";"SAISIE_COURRIEL";"QUOTA";"DUREE_SEANCE";"HORAIRE_DEFAUT";"REGLE_CALCUL"');
		fputs($fp,"\n");
		$q="SELECT * FROM circos";
		$r=query($q,$h);
		while ($row=@mysqli_fetch_array($r)) {
			$saisie='';
			switch($row['saisie_courriel']){
				case 2: $saisie='acadmique';break; 
				case 1: $saisie='obligatoire';break;
				default:$saisie='facultatif';break;
			}
			
			fputs($fp,sprintf("\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\"",
				$row['rne'], 
				$row['libelle'],
				$row['libelle_court'],
				$row['type_circo']==0?'relle':($row['type_circo']==1?'virtuelle':'transfert'),
				$row['courriel'],
				$saisie,
				str_replace('.',',',$row['quota']),
				str_replace('.',',',$row['duree_seance']),
				str_replace('.',',',$row['horaire_defaut']),
				$row['regle']+1
				)
			);
			fputs($fp,"\n");
		
		}
		if ($fp) {
			fclose($fp);	
			exportFichier($file,"Circos_");
			exit;
		}
		break;
	}
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-15" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
	</head>
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_circos_export?>">retour</a></li>
	  				<li><a href="#bas">bas</a></li>
				</ul>
			</div>
		  <div id="corps">
		    <h1>Exportation de la liste des circos </h1>
		    <h2>Liste compl&egrave;te des circonscriptions</h2>
		    <p>Format csv, pour tableur. </p>
		    <form name="form1" method="post" action="">
		      <p align="center">
		        <input name="Submit" type="submit" class="bouton_standard" value="Exporter" />
</p>
		    </form>
		    <p>&nbsp;</p>
		    <p>&nbsp; </p>
		  </div>
			<div class="menu_secondaire">
				<ul class="menu2">
					<li><a href="<?php print $url_ret_adm_circos_export?>">retour</a></li>
					<li><a href="#haut">haut</a></li>
				</ul>
			</div>
			<a name="bas" id="bas"></a>	
		</div>
	</body>
</html>