<?php
/*	
	Exportation des intervenants
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
	*/	
	require('_session.php');
	if (isset($_GET['url_ret'])) {
		$url_ret_adm_intervenants_export=strip_tags($_GET['url_ret']);
		$_SESSION['circonscript7_url_ret_adm_intervenants_export']=$url_ret_adm_intervenants_export;
	}
	else if (isset($_SESSION['circonscript7_url_ret_adm_intervenants_export'])) {
		$url_ret_adm_intervenants_export=$_SESSION['circonscript7_url_ret_adm_intervenants_export'];
	}
	else $url_ret_adm_intervenants_export="administration.php";
	if (!isset($_SESSION['circonscript7_administration'])) {
		header( 'Location: erreur.php?erreur=expiree');
		exit;
	}		
	
	$erreur='';
	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	$h=connect();
	debugInit();
	if (isset($_POST['Submit'])) {
		exporteIntervenantsCSV($h);
	}
	
function exporteIntervenantsCSV($h)
{
	global $erreur;
	
	while (!$erreur) {
		$file=tempnam('./temp',"csv");		
		if (!$file) {
			$erreur="Impossible de crer un nom de fichier temporaire.";
			break;
		}
		$fp=fopen($file,'w');
		if (!$fp) {
			$erreur="Impossible de crer un fichier temporaire.";
			break;
		}
		fputs($fp,'"CIV";"NOM";"PRENOM";"EMAIL";"NATSUPP";"LOGIN";"MOT_PASSE";"CRYPTAGE";"ORIGINE";"NB.INTERV.";"INTERVENTIONS"');
		fputs($fp,"\n");
		$q="SELECT intervenants.id_intervenant,civilite as civ,nom,prenom,intervenants.courriel AS email,fonction AS natsupp,utilisateurs.login,utilisateurs.mdp AS mot_passe, utilisateurs.codage, circos.libelle_court as circo, COUNT(interventions.id_intervention) AS nb_int FROM (intervenants,utilisateurs) LEFT JOIN circos ON intervenants.id_circo=circos.id_circo LEFT JOIN interventions ON interventions.id_intervenant=intervenants.id_intervenant WHERE intervenants.id_uti=utilisateurs.id_uti GROUP BY intervenants.id_intervenant ORDER BY nom ASC";
		$r=query($q,$h);
		while ($row=@mysqli_fetch_array($r)) {
			switch($row['civ']) {
				case 0: $civ='M.';break;
				case 1: $civ='Mme';break;
				default: $civ='';
			}
			$codage='non';
			$mdp=$row['mot_passe'];
			switch($row['codage']) {
				case 1: $codage='md5';break;
				case 2: $codage='aes';
					$mdp=bin2Hex($row['mot_passe']);
					break;
			}
			// si cryptage aes, alors envoie l'quivalent hexadcimal du mot de passe
			$id_intervenant=$row['id_intervenant'];
			$circos='';
			if ($id_intervenant && $row['nb_int']>0) $circos=queryValue("SELECT GROUP_CONCAT(DISTINCT circos.libelle_court ORDER BY circos.libelle_court ASC SEPARATOR ',') FROM interventions, dates,seances,animations,circos WHERE interventions.id_intervenant=$id_intervenant AND interventions.id_date=dates.id_date AND dates.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim AND circos.id_circo=animations.id_circo",$h);
			fputs($fp,sprintf("\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\"",
				$civ,
				$row['nom'], 
				$row['prenom'],
				$row['email'],
				str_replace('"','""',$row['natsupp']),
				$row['login'],
				$mdp!=''? '""'.str_replace('"','""',$mdp).'""':'',
				$codage,
				$row['circo'],
				$row['nb_int'],
				$circos
				)
			);
			fputs($fp,"\n");
		
		}
		if ($fp) {
			fclose($fp);	
			exportFichier($file,"Intervenants_");
			exit;
		}
		break;
	}
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-15" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
	</head>
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_intervenants_export?>">retour</a></li>
	  				<li><a href="#bas">bas</a></li>
				</ul>
			</div>
		  <div id="corps">
		    <h1>Exportation de la liste des intervenants </h1>
		    <h2>Liste compl&egrave;te des intervenants</h2>
		    <p>Format csv, pour tableur. </p>
		    <form name="form1" method="post" action="">
		      <p align="center">
		        <input name="Submit" type="submit" class="bouton_standard" value="Exporter" />
</p>
		    </form>
		    <p>&nbsp;</p>
		    <p>&nbsp; </p>
		  </div>
			<div class="menu_secondaire">
				<ul class="menu2">
					<li><a href="<?php print $url_ret_adm_intervenants_export?>">retour</a></li>
					<li><a href="#haut">haut</a></li>
				</ul>
			</div>
			<a name="bas" id="bas"></a>	
		</div>
	</body>
</html>
