<?php
/* 
	Exportation du plan de formation au format csv
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/

	require('_session.php');
	if (isset($_GET['url_ret'])) {
		$url_ret_adm_plan_export_xml=strip_tags($_GET['url_ret']);
		$_SESSION['circonscript7_url_ret_adm_plan_export_xml']=$url_ret_adm_plan_export_xml;
	}
	else if (isset($_SESSION['circonscript7_url_ret_adm_plan_export_xml'])) {
		$url_ret_adm_plan_export_xml=$_SESSION['circonscript7_url_ret_adm_plan_export_xml'];
	}
	else $url_ret_adm_plan_export_xml="adm_animations.php";
	
	$erreur='';
	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	require '_fonctions_animation.inc.php';
	if (!isset($_SESSION['circonscript7_id_circo'])) {
		header( 'Location: erreur.php?erreur=expiree');
		exit;
	}		
	$id_circo=$_SESSION['circonscript7_id_circo'];
	debugInit();
	$h=connect();
	ejecteSiFerme($h);
	$autoriser_plan_futur=queryValue("SELECT autoriser_plan_futur FROM circos WHERE id_circo=$id_circo",$h);
	if ($autoriser_plan_futur && isset($_SESSION['circonscript7_annee'])) $annee=$_SESSION['circonscript7_annee'];
	else $annee=0;
	while (isset($_POST['plan_final']) || isset($_POST['animations'])) {
			// URL de la dtd
			$domaine=$_SERVER['HTTP_HOST'];
			$path=$_SERVER['SCRIPT_NAME'];
			$t=explode('/',$path);
			if (sizeof($t)>1) {
				unset($t[sizeof($t)-1]);
				$path=implode('/',$t);
			}
			else $path='';
			$http='http';
			if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS']=='on') $http='https';
			$url_dtd="$http://$domaine$path/plan2.dtd";
			$implementation= new DOMImplementation();
			$dtd=$implementation->createDocumentType('plan','', $url_dtd);
			$dom = $implementation->createDocument('','',$dtd);
			$dom->formatOutput=true;
			$dom->encoding="UTF-8";
			$dom->standalone=true;
			ecrireAnimationsV2($id_circo,$dom,$annee,isset($_POST['plan_final']),$h);
				//$dom->validateOnParse=true;
			//if (!$dom->validate()) $erreur="Validation DOM incorrecte";
			if ($erreur) break;
			$file=tempnam("./temp","xml");
			if (!$file) {
				$erreur="Impossible de crer un nom de fichier temporaire.";
				break;
			}
			if (!$dom->save($file)){
				$erreur="Impossible de crer le fichier xml dans le dossier temporaire.";
				break;
			}
			if (isset($_POST['plan_final'])) $nouvFile="plan_final_";
			else $nouvFile="animations_";
			if ($annee) $nouvFile.="futur_";
			exportFichier($file,$nouvFile,"xml");
			exit;

	}
	

// plan==1: plan final
// plan = 0: uniquement les animations

function ecrireAnimationsV2($id_circo,&$dom,$annee,$plan,$h)
{
	global $erreur;
	if (!$id_circo ) {
		$erreur="id_circo erron ($id_circo)";
		return false;
	}
	// afficher toutes les animations et leurs exportations.
	if (!$plan) 
		$q="SELECT animations.id_anim,categories.codage AS categorie, domaines.libelle as domaine, domaines.id_domaine,intitule, themes.libelle as theme, themes.id_theme, description, animations.remarque, circos.libelle_court, animations.annule 
		FROM (positions, animations, themes, domaines, circos) 
		LEFT JOIN categories ON categories.id_categorie=animations.id_categorie 
		WHERE animations.id_circo=$id_circo AND positions.id_anim=animations.id_anim AND positions.id_domaine=domaines.id_domaine AND domaines.id_circo=$id_circo AND domaines.annee=$annee AND positions.id_theme=themes.id_theme AND animations.id_circo=circos.id_circo
		ORDER BY domaines.tri, themes.tri, positions.tri, animations.intitule ";
	else 
		
		$q="SELECT animations.id_anim,categories.codage AS categorie, domaines.libelle as domaine, domaines.id_domaine,intitule, themes.libelle as theme, themes.id_theme, description, animations.remarque, circos.libelle_court,animations.annule
			FROM (partages,seances,animations,positions,domaines,themes,circos)
			LEFT JOIN categories ON categories.id_categorie=animations.id_categorie 
			WHERE partages.id_circo=$id_circo AND partages.accepte<>0 AND partages.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim AND positions.id_anim=animations.id_anim AND positions.id_domaine=domaines.id_domaine AND domaines.id_circo=$id_circo AND domaines.annee=$annee AND positions.id_theme=themes.id_theme AND animations.id_circo=circos.id_circo
			GROUP BY animations.id_anim
			ORDER BY domaines.tri,themes.tri,positions.tri"; 
		
	
	
	$r=query($q,$h);
	$plan=$dom->createElement("plan");
	$domaine=NULL;
	$theme=NULL;
	$id_domaine_prec=0;
	$id_theme_prec=0;
	while ($row=@mysqli_fetch_array($r)) {
		$id_anim=$row['id_anim'];
		$animation=$dom->createElement("animation");
		$animation->setAttribute("circo",encode($row['libelle_court']));
		$animation->setAttribute("id_anim",$id_anim);
		$animation->setAttribute("annule",$row['annule']?'oui':'non');		
		if ($row['categorie']) {
			$e=$dom->createElement("categorie");
			$t=$dom->createTextNode(encode($row['categorie']));
			$e->appendChild($t);
			$animation->appendChild($e);
		}

		$e=$dom->createElement("intitule");
		$t=$dom->createTextNode(encode($row['intitule']));
		$e->appendChild($t);
		$animation->appendChild($e);

		if ($row['description']) {
			$e=$dom->createElement("description");
			$t=$dom->createTextNode(encode($row['description']));
			$e->appendChild($t);
			$animation->appendChild($e);
		}
		if ($row['remarque']) {
			$e=$dom->createElement("remarque");
			$t=$dom->createTextNode(encode($row['remarque']));
			$e->appendChild($t);
			$animation->appendChild($e);
		}
		$q="SELECT id_seance, max, public, cond FROM seances WHERE id_anim=$id_anim ORDER BY tri";
		$r2=query($q,$h);
		while ($row2=@mysqli_fetch_array($r2)) {
			$id_seance=$row2['id_seance'];
			$seance= $dom->createElement("seance");
			$seance->setAttribute("id_seance",$id_seance);	
	
			$max=intval($row2['max']);
			$cond=intval($row2['cond']);
			if ($max>0) {
				$e=$dom->createElement("max");
				$t=$dom->createTextNode($max);
				$e->appendChild($t);
				$seance->appendChild($e);
			}
			if ($row2['public']) {
				$e=$dom->createElement("public");
				$t=$dom->createTextNode(encode($row2['public']));
				$e->appendChild($t);
				$seance->appendChild($e);
			}
			if ($cond>0) {
				$e=$dom->createElement("condition_ouverture");
				if ($cond==1) $s="max";
				else $s='max-'.($cond-1);
				$t=$dom->createTextNode($s);
				$e->appendChild($t);
				$seance->appendChild($e);
			}
			// ici circos concernes
			$r5=query("SELECT circos.libelle_court FROM partages, circos WHERE partages.id_seance=$id_seance AND partages.id_circo=circos.id_circo ORDER BY circos.libelle_court ASC" ,$h);
			$circ='';
			while ($row3=@mysqli_fetch_row($r5)) {
				if ($circ) $circ.=',';
				$circ.=$row3[0];
			}
			$e=$dom->createElement("circos_concernees");
			$t=$dom->createTextNode(encode($circ));
			$e->appendChild($t);
			$seance->appendChild($e);
			
			$r3=query("SELECT id_date,date, horaire, lieu, duree, remarque FROM dates WHERE id_seance=$id_seance ORDER BY tri",$h);
			while ($row3=@mysqli_fetch_array($r3)) {
				$date=$dom->createElement("date");
				$duree=doubleval($row3['duree']);
				$id_date=$row3['id_date'];
				$date->setAttribute("id_date",$id_date);				
				if ($row3['date'] && $row3['date']!='9999-12-31') {
					$e=$dom->createElement("date_seance");
					if( $row3['date']=='9999-12-30') 
						$t=$dom->createTextNode(encode("Tlformation"));
					else
						$t=$dom->createTextNode($row3['date']);
					$e->appendChild($t);
					$date->appendChild($e);
				}
				if ($row3['date']<'9999-12-30') {
					$e=$dom->createElement("horaire");
					$t=$dom->createTextNode($row3['horaire']);
					$e->appendChild($t);
					$date->appendChild($e);
				}					
				$e=$dom->createElement("duree");
				$t=$dom->createTextNode($duree);
				$e->appendChild($t);
				$date->appendChild($e);

				if ($row3['lieu']) {
					$e=$dom->createElement("lieu");
					$t=$dom->createTextNode(encode($row3['lieu']));
					$e->appendChild($t);
					$date->appendChild($e);
				}			
				if ($row3['remarque']) {
					$e=$dom->createElement("remarque_seance");
					$t=$dom->createTextNode(encode($row3['remarque']));
					$e->appendChild($t);
					$date->appendChild($e);
				}
				$r4=query("SELECT civilite, nom, prenom,fonction,courriel FROM intervenants, interventions WHERE interventions.id_date=$id_date AND interventions.id_intervenant=intervenants.id_intervenant",$h);
				while ($row4=@mysqli_fetch_array($r4)) {
					$intervenant=$dom->createElement("intervenant");
					$civ='';
					if ($row4['civilite']==0) $civ='M.';
					else if($row4['civilite']==1) $civ='Mme';
					$e=$dom->createElement("civ");
					$t=$dom->createTextNode($civ);
					$e->appendChild($t);
					$intervenant->appendChild($e);
					
					$e=$dom->createElement("nom");
					$t=$dom->createTextNode(encode($row4['nom']));
					$e->appendChild($t);
					$intervenant->appendChild($e);
					
					if ($row4['prenom']) {
						$e=$dom->createElement("prenom");
						$t=$dom->createTextNode(encode($row4['prenom']));
						$e->appendChild($t);
						$intervenant->appendChild($e);
					}
					if ($row4['fonction']) {
						$e=$dom->createElement("fonction");
						$t=$dom->createTextNode(encode($row4['fonction']));
						$e->appendChild($t);
						$intervenant->appendChild($e);
					}
					if ($row4['courriel']) {
						$e=$dom->createElement("courriel");
						$t=$dom->createTextNode(encode($row4['courriel']));
						$e->appendChild($t);
						$intervenant->appendChild($e);
					}
					$date->appendChild($intervenant);
				}
				$seance->appendChild($date);
			}
			$animation->appendChild($seance);
		}
		$id_domaine=$row['id_domaine'];
		$id_theme=$row['id_theme'];
		if ($id_theme!=$id_theme_prec) {
			if ($theme && $domaine) {
				$domaine->appendChild($theme);
			}
			$id_theme_prec=$id_theme;
			$theme=$dom->createElement("theme");
			$theme->setAttribute("id_theme",$row['id_theme']);	
			$e=$dom->createElement("theme_nom");
			$t=$dom->createTextNode(encode($row['theme']));
			$e->appendChild($t);
			$theme->appendChild($e);
		}
		debug("$id_domaine,$id_domaine_prec,$id_theme,$id_theme_prec");
		$theme->appendChild($animation);
		if ($id_domaine!=$id_domaine_prec) {
			if ($domaine) {
				$domaine->appendChild($theme);
				$plan->appendChild($domaine);
			}
			$id_domaine_prec=$id_domaine;
			$id_theme_prec=0;
			$domaine=$dom->createElement("domaine");
			$domaine->setAttribute("id_domaine",$row['id_domaine']);	
			$e=$dom->createElement("domaine_nom");
			$t=$dom->createTextNode(encode($row['domaine']));
			$e->appendChild($t);
			$domaine->appendChild($e);
		}		
	}
	if ($domaine && $theme) {
		$domaine->appendChild($theme);
		$plan->appendChild($domaine);
	}	
	$dom->appendChild($plan);	
	return !$erreur;
}

function encode( $s)
{
	return iconv('ISO-8859-15','UTF-8',str_replace(chr(146),'\'',$s));
}	
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-155" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
	</head>
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_plan_export_xml?>">retour</a></li>
	  				<li><a href="#bas">bas</a></li>
				</ul>
			</div>
			<div id="corps">	 
			  <h1>Exportation du plan de formation au format XML <?php 
			  	if ($annee) print '(plan futur)';
				?>
			  </h1>
			    <?php if ($erreur) print "<p class=\"erreur\">$erreur</p>";?> 
			      <p>Les accents sont cod&eacute;s au format UTF-8. </p> 
				  <form name="form1" method="post" action="">
			        <h2>Le plan de formation final
			          <input name="plan_final" type="submit" class="bouton_standard" id="plan_final" value="Exporter!" />
                    </h2>
			        <p>C'est le plan final pr&eacute;sent&eacute; aux stagaires de la circonscription, contenant aussi les animations import&eacute;es.</p>
			        <h2>Les animations propos&eacute;es par la circonscription
			          <input name="animations" type="submit" class="bouton_standard" id="animations" value="Exporter!" />
                    </h2>
			        <p>La liste de toutes les animations &eacute;labor&eacute;es par la circo, comprenant celles sp&eacute;cifiques  et celles export&eacute;es. Ne contient pas les animations import&eacute;es. </p>
              </form>
			      </div>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_plan_export_xml?>">retour</a></li>
		  			<li><a href="#haut">haut</a></li>
				</ul>
			</div>
			<a name="bas" id="bas"></a>	
		</div>
	</body>
</html>