<?php
/*	
	Recherche des doublons stagiaires
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/
	require('_session.php');
	if (isset($_GET['url_ret'])) {
		$url_ret_adm_stagiaires_doublons=strip_tags($_GET['url_ret']);
		$_SESSION['circonscript7_url_ret_adm_stagiaires_doublons']=$url_ret_adm_stagiaires_doublons;
	}
	else if (isset($_SESSION['circonscript7_url_ret_adm_stagiaires_doublons'])) {
		$url_ret_adm_stagiaires_doublons=$_SESSION['circonscript7_url_ret_adm_stagiaires_doublons'];
	}
	else $url_ret_adm_stagiaires_doublons="adm_stagiaires_doublons.php";

	$erreur='';
	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	
	if (!isset($_SESSION['circonscript7_id_circo'])) {
		header( 'Location: erreur.php?erreur=expiree');
		exit;
	}		
	$id_circo=$_SESSION['circonscript7_id_circo'];
	$h=connect();
	ejecteSiFerme($h);
	debugInit();
	$type_circo=queryValue("SELECT type_circo FROM circos WHERE id_circo=$id_circo",$h);
	if ($type_circo==1 ){
		header('Location: erreur.php?erreur=acces_page');
		exit;
	}		
	
	//diffrents tris en cours
	$tris=array(
		'nom_asc'=> 'nom_stagiaire ASC',
		'nom_desc' => 'nom_stagiaire DESC',
		'ecole_asc'=>'nom_ecole ASC, nom_stagiaire ASC',
		'ecole_desc'=>'nom_ecole DESC,nom_stagiaire ASC',
	);
	
	if (isset($_GET['tri'])) {
		$tri_adm_stagiaires_doublons=$tris[$_GET['tri']];
		if (!isset($tri_adm_stagiaires_doublons)) $tri_adm_stagiaires_doublons=$tris['nom_asc'];
		$_SESSION['circonscript7_tri_adm_stagiaires_doublons']=$tri_adm_stagiaires_doublons;
	}
	else if (isset($_SESSION['circonscript7_tri_adm_stagiaires_doublons'])) {
		$tri_adm_stagiaires_doublons=$_SESSION['circonscript7_tri_adm_stagiaires_doublons'];
	}
	else {
		$tri_adm_stagiaires_doublons=$tris['nom_asc'];
		$_SESSION['circonscript7_tri_adm_stagiaires_doublons']=$tri_adm_stagiaires_doublons;
	}	
	

function afficheListeStagiaires($h)
{
	global $tri_adm_stagiaires_doublons,$id_circo;
	$impair=0;
	$q="SELECT s1.id_stagiaire, s2.id_stagiaire FROM stagiaires as s1,stagiaires as s2, ecoles as e1, ecoles as e2
WHERE s1.id_stagiaire<s2.id_stagiaire
AND s1.id_ecole = e1.id_ecole
AND e1.id_circo =$id_circo
AND s2.id_ecole = e2.id_ecole
AND e2.id_circo =$id_circo
AND s1.nom_f = s2.nom_f
AND s1.prenom_f = s2.prenom_f";

	$r=query($q,$h);
	$stags=array();
	$n=0;
	while ($row=@mysqli_fetch_row($r)) {
		$id1=$row[0];
		$id2=$row[1];
		for ($i=0;$i<$n;++$i) if ($stag[$i]==$id1) break;
		if ($i==$n) $stag[$n++]=$id1;
		for ($i=0;$i<$n;++$i) if ($stag[$i]==$id2) break;
		if ($i==$n) $stag[$n++]=$id2;
	}
	if ($n>0) {
			$q="SELECT stagiaires.id_stagiaire, concat( stagiaires.nom, ' ', stagiaires.prenom ) AS nom_stagiaire, ecoles.nom AS nom_ecole, stagiaires.niveau, quotite, quota_reel
		FROM stagiaires, ecoles";
		$q.=sprintf(" WHERE stagiaires.id_ecole=ecoles.id_ecole AND stagiaires.id_stagiaire IN (%s)",implode(',',$stag));
		if (isset($tri_adm_stagiaires_doublons)) $q.=" ORDER BY $tri_adm_stagiaires_doublons";
		else $q.=" ORDER BY nom_stagiaire ASC";
		
		$r=query($q,$h);	
		while ($row=@mysqli_fetch_array($r)) {
			$id_stagiaire=$row['id_stagiaire'];
			$duree_convoc=queryValue("SELECT SUM(dates.duree) FROM convocations,dates WHERE convocations.id_stagiaire=$id_stagiaire AND dates.id_seance=convocations.id_seance",$h);
			$duree_inscr=queryValue("SELECT SUM(dates.duree) FROM inscriptions,dates WHERE inscriptions.id_stagiaire=$id_stagiaire AND dates.id_seance=inscriptions.id_seance",$h);
			
			if ($impair)
				print "<tr class=\"seance_impaire\">\n";
			else
				print "<tr class=\"seance_paire\">\n";
			//print("<td>&nbsp;</td>\n");
			printf("<td><a href=\"adm_stagiaire_edite.php?id_stagiaire=$id_stagiaire&amp;url_ret=adm_stagiaires_doublons.php\">%s</a></td>\n",htmlentities($row['nom_stagiaire'],ENT_COMPAT,'ISO-8859-15'));
			
			//printf("<td>%s</td>\n",htmlentities($row['nom_stagiaire'],ENT_COMPAT,'ISO-8859-15'));
			printf("<td>%s</td>\n",htmlentities(substr($row['niveau'],1,strlen($row['niveau'])-2),ENT_COMPAT,'ISO-8859-15'));
			printf("<td>%s</td>\n",htmlentities($row['nom_ecole'],ENT_COMPAT,'ISO-8859-15'));
			printf("<td>%.2f</td>\n",$row['quotite']);
			printf("<td>%s</td>\n",reelEnHeure($row['quota_reel']));
			printf("<td>%s&nbsp;</td>\n",reelEnHeure($duree_inscr));
			printf("<td>&nbsp;%s</td>\n",reelEnHeure($duree_convoc));
			print "</tr>\n";
		}
	}
	else print "<tr><td colspan=\"7\"><h3>Aucun doublon trouv&eacute;.</h3></td></tr>\n";
}
	
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-15" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
		<script type="text/javascript" src="popup.js"></script>
	    <script type="text/JavaScript" charset="ISO-8859-15">
<!--

function cocheTout(obj)
{
  // on rcupre le formulaire des objets  modifier
  leForm = obj.form

  laListe = leForm["convoque[]"]

  if (laListe != null){
	if (laListe.length != null){
	  // on modifie tous les lments
	  for(i=0; i < laListe.length; i++) {
		laListe[i].checked = obj.checked
	  }
	} else {
	  laListe.checked = obj.checked
	}
  }
}
//-->
</script>
	</head>
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_stagiaires_doublons?>">retour</a></li>
	  				<li><a href="#bas">bas</a></li>
					</ul>
			</div>
		  <div id="corps">
		    <h2>Liste des doublons POSSIBLES </h2>
		    <p class="important">Le logiciel ne renseignant pas les dates de naissances, il n'a aucun moyen de diff&eacute;rencer les vrais et les faux doublons. Soyez prudents!</p>
		    <p>Cliquer sur le nom permet d'arriver &agrave; la fiche du stagiaire. De l&agrave;, vous pouvez supprimer la fiche.</p>
		    <p>La recherche &eacute;tant fort longue, elle ne d&eacute;marre pas automatiquement. Veuillez cliquer sur le bouton ci-desous.</p>
		    <form id="form1" name="form1" method="post" action="">
		      <div align="center">
		        <input name="Submit" type="submit" class="bouton_standard" value="D&eacute;marrer la recherche des doublons" />
	            </div>
		    </form>
		    <p class="important">
		      <?php if ($erreur) print "<p class=\"erreur\">$erreur</p>";?>
	        </p>
		    <form method="post" action="">
				  <table>
                  <tr class="table_entete">
                    <td rowspan="2">Nom stagiaire&nbsp; <a href="adm_stagiaires_doublons.php?tri=nom_asc"><img src="images/fleche_haut.png" alt="tri par nom ascendant" width="11" height="11" border="0" /></a><a href="adm_stagiaires_doublons.php?tri=nom_desc"><img src="images/fleche_bas.png" alt="tri par nom descendant" width="11" height="11" border="0" /></a></td>
                    <td rowspan="2">Niveau&nbsp;<br /></td>
                    <td rowspan="2">Ecole<a href="adm_stagiaires_doublons.php?tri=ecole_asc"><img src="images/fleche_haut.png" alt="tri par &eacute;cole ascendant" width="11" height="11" border="0" /></a><a href="adm_stagiaires_doublons.php?tri=ecole_desc"><img src="images/fleche_bas.png" alt="tri par &eacute;cole descendant" width="11" height="11" border="0" /></a></td>
                    <td rowspan="2">Quotit&eacute;<br /></td>
                    <td rowspan="2">Quota&nbsp;<a href="adm_stagiaires_doublons.php?tri=quota_asc"><br />
                    </a></td>
                    <td colspan="2">Dur&eacute;es totales </td>
                  </tr>
                  <tr class="table_entete">
                    <td>inscr&deg;</td>
                    <td>conv&deg;</td>
                  </tr>
				<?php if (isset($_POST['Submit'])) afficheListeStagiaires($h) ?>
				</table>
		    </form>
		  </div>
			<div class="menu_secondaire">
				<ul class="menu2">
					<li><a href="<?php print $url_ret_adm_stagiaires_doublons?>">retour</a></li>
					<li><a href="#haut">haut</a></li>
				</ul>
			</div>
			<a name="bas" id="bas"></a>	
		</div>
	</body>
</html>