<?php
/*	
	Exportation des stagiaires
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/

	require('_session.php');
	if (isset($_GET['url_ret'])) {
		$url_ret_adm_stagiaires_export=strip_tags($_GET['url_ret']);
		$_SESSION['circonscript7_url_ret_adm_stagiaires_export']=$url_ret_adm_stagiaires_export;
	}
	else if (isset($_SESSION['circonscript7_url_ret_adm_stagiaires_export'])) {
		$url_ret_adm_stagiaires_export=$_SESSION['circonscript7_url_ret_adm_stagiaires_export'];
	}
	else $url_ret_adm_stagiaires_export="adm_stagiaires.php";
	
	$erreur='';
	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	if (!isset($_SESSION['circonscript7_id_circo'])) {
		header( 'Location: erreur.php?erreur=expiree');
		exit;
	}		
	$id_circo=$_SESSION['circonscript7_id_circo'];
	$h=connect();
	ejecteSiFerme($h);
	debugInit();
	$type_circo=queryValue("SELECT type_circo FROM circos WHERE id_circo=$id_circo",$h);
	if ($type_circo==1 ){
		header('Location: erreur.php?erreur=acces_page');
		exit;
	}		
	if (isset($_POST['Submit'])) {
		exporteStagiairesCSV($h);
		
	
	}
	
function exporteStagiairesCSV($h)
{
	global $erreur,$id_circo;
	$nb_groupes=queryValue("SELECT COUNT(*) FROM groupes WHERE id_circo=$id_circo",$h);
	$codcirco=queryValue("SELECT rne FROM circos WHERE id_circo=$id_circo",$h);
	while (!$erreur) {
		$file=tempnam('./temp',"csv");		
		if (!$file) {
			$erreur="Impossible de crer un nom de fichier temporaire.";
			break;
		}
		$fp=fopen($file,'w');
		if (!$fp) {
			$erreur="Impossible de crer un fichier temporaire.";
			break;
		}
		fputs($fp,'"CODCIRCO";"NOM";"PRENOM";"EMAIL";"SSO_LOGIN";"NIVEAU";"QUOTSERV";"QUOTA";"QUOTA_REEL";"ECOLE";"NUMRNE";"COURRIEL_EC";"INSCR.";"CONV.";"LOGIN";"MOT_PASSE";"CRYPTAGE"');		
		if($nb_groupes>0) fputs($fp,';"GROUPE"');
		fputs($fp,"\n");
		
		$q="SELECT id_stagiaire,stagiaires.nom, prenom,stagiaires.courriel,niveau,quotite,quota,quota_reel,ecoles.nom as ecole, rne, ecoles.courriel as courriel_ec, mdp, groupes.libelle as groupe, utilisateurs.login, utilisateurs.mdp, utilisateurs.codage,utilisateurs.sso_login FROM (stagiaires, ecoles,utilisateurs) LEFT JOIN groupes ON stagiaires.id_groupe=groupes.id_groupe WHERE stagiaires.id_ecole=ecoles.id_ecole AND ecoles.id_circo=$id_circo AND stagiaires.id_uti=utilisateurs.id_uti ORDER BY stagiaires.nom";
		$r=query($q,$h);
		while ($row=@mysqli_fetch_array($r)) {
			$id_stagiaire=$row['id_stagiaire'];
			$inscr=queryValue("SELECT sum(duree) FROM dates,seances, inscriptions WHERE inscriptions.id_stagiaire=$id_stagiaire AND inscriptions.id_seance=seances.id_seance AND dates.id_seance=seances.id_seance",$h);
			$conv=queryValue("SELECT sum(duree) FROM dates,seances, convocations WHERE convocations.id_stagiaire=$id_stagiaire AND convocations.id_seance=seances.id_seance AND dates.id_seance=seances.id_seance",$h);
			if ($inscr=='') $inscr="0.0";
			if ($conv=='') $conv="0.0";
			$nom='"'.$row['nom'].'"';
			$prenom='"'.$row['prenom'].'"';
			$courriel='"'.$row['courriel'].'"';
			$sso_login='"'.$row['sso_login'].'"';
			$niveau='"'.$row['niveau'].'"';
			$quotite='"'.str_replace('.',',',$row['quotite']).'"';
			$quota='"'.str_replace('.',',',$row['quota']).'"';
			$quota_effectif= '"'.str_replace('.',',',$row['quota_reel']).'"';
			$ecole='"'.$row['ecole'].'"';
			$rne='"'.$row['rne'].'"';
			$courriel_ec='"'.$row['courriel_ec'].'"';
			$inscr='"'.str_replace('.',',',$inscr).'"';
			$conv='"'.str_replace('.',',',$conv).'"';
			$mdp=$row['mdp'];
			if ($row['codage']==2) $mdp=bin2hex($mdp); //si aes
			$mdp='"'.$mdp.'"';
			$codage='"non"';
			switch($row['codage']) {
				case 0: $codage='"non"';break;
				case 1: $codage='"md5"'; break;
				case 2: $codage='"aes"'; break;
			}
			$groupe='"'.str_replace('"','""',$row['groupe']).'"';
			$login='"'.str_replace('"','""',$row['login']).'"';
			fputs($fp,"\"$codcirco\";$nom;$prenom;$courriel;$sso_login;$niveau;$quotite;$quota;$quota_effectif;$ecole;$rne;$courriel_ec;$inscr;$conv;$login;\"\"$mdp\"\";$codage");
			if ($nb_groupes>0) fputs($fp,";$groupe");
			fputs($fp,"\n");
		
		}
		if ($fp) {
			fclose($fp);	
			exportFichier($file,"Stagiaires_");
			exit;
		}
		break;
	}
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-15" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
	</head>
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_stagiaires_export?>">retour</a></li>
	  				<li><a href="#bas">bas</a></li>
				</ul>
			</div>
		  <div id="corps">
		    <h1>Exportation de la liste des stagiaires</h1>
		    <h2>Liste des stagiaires de la circonscription </h2>
		    <p>Format csv, pour tableur. Inclut la dur&eacute;e totale des animations auxquelles chaque stagiaire est inscrit et convoqu&eacute;. </p>
		    <form name="form1" method="post" action="">
		      <p>&nbsp;</p>
		      <p align="center">
		        <input name="Submit" type="submit" class="bouton_standard" value="Exporter" />
</p>
		    </form>
		    <h2>Explications sur certains champs de l'exportation </h2>
		    <p>En vert, le minimum requis pour une future importation. </p>
		    <table border="1" cellpadding="1" cellspacing="2">
              <tr>
                <td bgcolor="#00CC33">CODCIRCO</td>
                <td><p>Num&eacute;ro RNE de la circonscription. </p>                </td>
              </tr>
              <tr>
                <td bgcolor="#00CC33">NUMRNE</td>
                <td><p>Num&eacute;ro RNE de l'&eacute;cole dans laquelle se trouve le stagiaire. <strong>Seules les &eacute;coles d&eacute;j&agrave; programm&eacute;es dans votre circonscription sont prises en compte.</strong></p></td>
              </tr>
              <tr>
                <td bgcolor="#00CC33">NOM</td>
                <td><p>Nom du stagiaire</p></td>
              </tr>
              <tr>
                <td bgcolor="#00CC33">PRENOM</td>
                <td><p>Pr&eacute;nom du stagiaire</p></td>
              </tr>
              <tr>
                <td>CRYPTAGE</td>
                <td><p>Cryptage du mot de passe:</p>
                    <p>non: aucun cryptage</p>
                  <p>aes: cryptage aes</p>
                  <p>md5: cryptage md5 (version 3 de Circonscript) </p></td>
              </tr>
              <tr>
                <td>MOT_PASSE</td>
                <td><p>Mot de passe du stagiaire. Figure entre guillemets (&quot;...&quot;), afin d'&eacute;viter le formatage automatique sous Excel (0 du d&eacute;but qui disparaissent...). Les mots de passe cod&eacute;s en hexac&eacute;dimal provenant de l'exportation sont accept&eacute;s. </p></td>
              </tr>
              
              <tr>
                <td>EMAIL</td>
                <td><p>Courriel de l'enseignant. Si absent, l'enseignant n'aura pas d'adresse courriel.</p></td>
              </tr>
              <tr>
                <td>SSO_LOGIN</td>
                <td><p>Identifiant d'acc&egrave;s au portail de services.</p>
                    <p>G&eacute;n&eacute;ralement, c'est l'identifiant iProf. </p></td>
              </tr>
              <tr>
                <td>QUOTSERV</td>
                <td><p>Quotit&eacute; de service. Ce champ contient la quotit&eacute; de service, entre 0 et 100%. </p></td>
              </tr>
              <tr>
                <td>NIVEAU</td>
                <td><p>Niveau de classe du stagiaire: les niveaux sont pr&eacute;sent&eacute;s sous la forme: /CP/CE1/DIRECTION/ ce qui facilite le filtrage. Si vide, pas de niveau d&eacute;fini. </p>                </td>
              </tr>
              <tr>
                <td>QUOTA</td>
                <td><p>Nombre d&eacute;cimal: heures d'animations p&eacute;dagogiques &agrave; faire par le stagiaire (<strong>pour</strong> <strong>une quotit&eacute; de 100</strong>). C'est un nombre d&eacute;cimal (donc 5h15mn vaut 5,25). </p></td>
              </tr>
              <tr>
                <td>QUOTA_REEL</td>
                <td><p>Nombre d&eacute;cimal: nombre d'heures d'animations p&eacute;dagogiques &agrave; faire r&eacute;ellement par le stagiaire. C'est un nombre d&eacute;cimal (donc 5h15mn vaut 5,25). En g&eacute;n&eacute;ral, c'est &eacute;gal au QUOTA x QUOTSERV, sauf si des r&egrave;gles particuli&egrave;res de gestion s'appliquent. </p></td>
              </tr>
              <tr>
                <td>GROUPE</td>
                <td><p>Nom du groupe auquel appartient le stagiaire. Les groupes doivent d&eacute;j&agrave; &ecirc;tre programm&eacute;s dans la base, sinon le champ sera ignor&eacute;. </p></td>
              </tr>
              <tr>
                <td>ECOLE</td>
                <td><p>Nom de l'&eacute;cole de rattachement du stagiaire. </p></td>
              </tr>
              <tr>
                <td>COURRIEL_EC</td>
                <td><p>Adresse courriel de l'&eacute;cole de rattachement du stagiaire. </p>                </td>
              </tr>
              <tr>
                <td>INSCR</td>
                <td><p>Nombre d'heures totales d'animations p&eacute;dagogiques pour lesquelles le stagiaire s'est inscrit. Nombre d&eacute;cimal. </p></td>
              </tr>
              <tr>
                <td>CONV</td>
                <td><p>Nombre d'heures totales d'animations p&eacute;dagogiques auxquelles le stagiaire est convoqu&eacute;. Nombre d&eacute;cimal. </p></td>
              </tr>
            </table>
		    <p>&nbsp; </p>
		  </div>
			<div class="menu_secondaire">
				<ul class="menu2">
					<li><a href="<?php print $url_ret_adm_stagiaires_export?>">retour</a></li>
					<li><a href="#haut">haut</a></li>
				</ul>
			</div>
			<a name="bas" id="bas"></a>	
		</div>
	</body>
</html>
