<?php
/* 
	Restaurer les tables
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/
	require('_session.php');
	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	debugInit();
	$erreur='';
	if (!isset($_SESSION['circonscript7_id_uti'])) {
		header('Location:erreur.php?erreur=expiree');
		exit;
	}
	$id_uti=$_SESSION['circonscript7_id_uti'];
	
	$_SESSION['circonscript7_session_menu_page']=8;
	$id_stagiaires=array();
	$id_admins=array();
	$id_intervenants=array();
	$h=connect();
	ejecteSiFerme($h);
	// vrifie si le mot de passe ne doit pas tre chang.
	$r=query("SELECT codage FROM utilisateurs WHERE id_uti=$id_uti",$h);
	if (@mysqli_num_rows($r)==0) {
		header('Location: erreur.php?erreur=acces');
		exit;
	}
	$row=@mysqli_fetch_row($r);
	$codage=$row[0];
	if ($codage==0 && !isset($_SESSION['circonscript7_sso'])) { 
		$_SESSION['circonscript7_compte_provisoire']=1;
		header('Location: compte_mdp.php');
		exit;
	}
	$_SESSION['circonscript7_compte_provisoire']=0;
	// s'il y a un  compte stagiaire dans une circo virtuelle  transfert demande  une affectation
	$r=query("SELECT stagiaires.id_stagiaire FROM stagiaires, ecoles, circos WHERE stagiaires.id_uti=$id_uti AND stagiaires.id_ecole =ecoles.id_ecole AND ecoles.id_circo=circos.id_circo AND circos.type_circo=2",$h);
	if (@mysqli_num_rows($r)>0) {// il y a un compte dans une circo virtuelle de transfert
		//s'il y a des comptes dans des circos relles, on supprime les comptes dans les circos virtuelles de transfert.
		$n=queryValue("SELECT COUNT(*) FROM stagiaires, ecoles, circos WHERE stagiaires.id_uti=$id_uti AND stagiaires.id_ecole =ecoles.id_ecole AND ecoles.id_circo=circos.id_circo AND circos.type_circo=0",$h);
		if ($n==0) {	// pas de comptes rels: va demander au stagiaire de choisir une affectation
			header('Location: ins_transfert.php');
			exit;
		}
		// il y a des comptes rels: supprimer les comptes des circos virtuelles de transfert
		while ($row=@mysqli_fetch_row($r)) {
			$id_stagiaire=$row[0];
			query("DELETE FROM inscriptions WHERE id_stagiaire='$id_stagiaire'",$h);
			query("DELETE FROM convocations WHERE id_stagiaire='$id_stagiaire'",$h);
			query("DELETE FROM absences WHERE id_stagiaire='$id_stagiaire'",$h);
			query("DELETE FROM stagiaires WHERE id_stagiaire='$id_stagiaire'",$h);
		}
	}

	// actualits
	$r=query("SELECT message_compte FROM general",$h);
	$actu='';
	if ($r) {
		$row=@mysqli_fetch_row($r);
		$actu=$row[0];
	}
	// recherche l'utilisateur sur les diffrents personnels
	$r=query("SELECT id_stagiaire FROM stagiaires WHERE id_uti=$id_uti",$h);
	while ($row=@mysqli_fetch_row($r)) $id_stagiaires[]=$row[0];
	$r=query("SELECT id_admin FROM administrateurs WHERE id_uti=$id_uti",$h);
	while ($row=@mysqli_fetch_row($r)) $id_admins[]=$row[0];
	$r=query("SELECT id_intervenant FROM intervenants WHERE id_uti=$id_uti",$h);
	while ($row=@mysqli_fetch_row($r)) $id_intervenants[]=$row[0];
	// dtermine le niveau de scurit du mot de passe
	if (count($id_admins)>0) $securite=1;
	else $securite=0;
	$_SESSION['circonscript7_compte_securite']=$securite;
	// enregistre la date et l'heure de connexion et rcupre la dernire
	$dtConnexion='';
	if (isset($_SESSION['circonscript7_compte_dtconnexion'])) $dtConnexion=$_SESSION['circonscript7_compte_dtconnexion'];
	$login=htmlentities(queryValue("SELECT login FROM utilisateurs WHERE id_uti=$id_uti",$h),ENT_COMPAT,'ISO-8859-15');
	if (isset($_POST['id']) && isset($_POST['valeur'])) while(1){
		$id=$_POST['id'];
		$val=abs(intval($_POST['valeur']));
		if ($id=='id_stagiaire') {
			$id_stagiaire=$val;
			$n=queryValue("SELECT COUNT(*) FROM stagiaires WHERE id_uti=$id_uti AND id_stagiaire=$id_stagiaire",$h);
			if (!$n) {
				$erreur="Erreur sur l'identifiant du stagiaire.";
				break;
			} 
			detruireVariablesSession();
			$_SESSION['circonscript7_id_stagiaire']=$id_stagiaire;
			header('Location: ins_menu.php');
			exit;
		}
		else if ($id=='id_intervenant') {
			$id_intervenant=$val;
			$n=queryValue("SELECT COUNT(*) FROM intervenants WHERE id_uti=$id_uti AND id_intervenant=$id_intervenant",$h);
			if (!$n) {
				$erreur="Erreur sur l'identifiant de l'intervenant.";
				break;
			} 
			detruireVariablesSession();
			$_SESSION['circonscript7_id_intervenant']=$id_intervenant;
			header('Location: int_accueil.php');
			exit;
		}
		else if ($id=='id_circo') {
			$id_circo=$val;
			$n=queryValue("SELECT COUNT(*) FROM administrateurs, droits WHERE administrateurs.id_uti=$id_uti AND droits.id_admin=administrateurs.id_admin AND droits.id_circo=$id_circo",$h);
			if (!$n) {
				$erreur="Erreur sur l'identifiant de circonscription.";
				break;
			} 
			detruireVariablesSession();
			$_SESSION['circonscript7_id_circo']=$id_circo;
			
			header('Location: adm_circo_bienvenue.php');
			exit;
		}
		break;
	}
	
	
function afficheConnexions($h)
{
	global $id_stagiaires,$id_uti,$id_admins,$id_intervenants,$erreur;
	$nbComptesSupprimables=0;
	
	if (count($id_stagiaires)>0) {
		print "<h2>Acc&egrave;s enseignant</h2>\n";
		print "<ul class=\"fleche\">\n";
		foreach($id_stagiaires as $id_stagiaire) {
			$r=query("SELECT concat(stagiaires.nom,' ',stagiaires.prenom), ecoles.nom, circos.libelle FROM stagiaires, ecoles,circos WHERE stagiaires.id_stagiaire=$id_stagiaire AND stagiaires.id_ecole=ecoles.id_ecole AND ecoles.id_circo=circos.id_circo",$h);
			while ($row=@mysqli_fetch_row($r)) {
				printf("<li><p><a href=\"javascript:connect('id_stagiaire',$id_stagiaire)\">%s</a> %s (%s)</p></li>\n", htmlentities($row[0],ENT_COMPAT,'ISO-8859-15'),htmlentities($row[1],ENT_COMPAT,'ISO-8859-15'),htmlentities($row[2],ENT_COMPAT,'ISO-8859-15'));
			}
			$nb=queryValue("SELECT COUNT(*) FROM inscriptions WHERE id_stagiaire=$id_stagiaire",$h);
			if($nb==0) $nb=queryValue("SELECT COUNT(*) FROM convocations WHERE id_stagiaire=$id_stagiaire",$h);
			if ($nb==0)++$nbComptesSupprimables;
		}
		print "</ul>\n";
	}
	
	if (count($id_intervenants)>0) {
		print "<h2>Acc&egrave;s intervenant</h2>\n";
		print "<ul class=\"fleche\">\n";
		foreach($id_intervenants as $id_intervenant) {
			$r=query("SELECT concat(intervenants.nom,' ',intervenants.prenom), ouvert FROM intervenants WHERE id_intervenant=$id_intervenant",$h);
			while ($row=@mysqli_fetch_row($r)) {
				if ($row[1]) printf("<li><p><a href=\"javascript:connect('id_intervenant',$id_intervenant)\">%s</a></p></li>\n", htmlentities($row[0],ENT_COMPAT,'ISO-8859-15'));
				else printf("<li><p>%s [acc&egrave;s ferm&eacute;]</p></li>",htmlentities($row[0],ENT_COMPAT,'ISO-8859-15'));
			}
		}
		print "</ul>\n";
		if (count($id_intervenants)>1) print "<p class=\"important\">Attention ! Vous &ecirc;tes r&eacute;f&eacute;renc&eacute;(e) plusieurs fois. Pr&eacute;venez l'administrateur principal afin qu'il fusionne vos diffrents comptes.</p>\n";
	}
	if (count($id_admins)>0) for ($i=0;$i<count($id_admins);++$i){
		$id_admin=$id_admins[$i];
		$type=queryValue("SELECT type_admin FROM administrateurs WHERE id_admin=$id_admin",$h);
		$_SESSION['circonscript7_id_admin']=$id_admin;
		if ($type==1) { //admin principal 
			if (!isset($_SESSION['circonscript7_administration'])) $_SESSION['circonscript7_administration']=$id_admin;
			print "<h2>Acc&egrave;s administrateur principal</h2>\n";
			print "<ul class=\"fleche\">\n";
			print "<li><p><a href=\"administration.php\">Administration</a></p></li>\n";
			print "</ul>\n";
		}	
		else {
			print "<h2>Acc&egrave;s aux circonscriptions</h2>\n";
			print "<ul class=\"fleche\">\n";
			$r=query("SELECT circos.id_circo, circos.libelle FROM circos, droits WHERE droits.id_admin=$id_admin AND droits.id_circo=circos.id_circo ORDER BY circos.libelle",$h);
			if (@mysqli_num_rows($r)==0) 
				print "<li><p>Aucun acc&egrave;s aux circos n'est ouvert. Pr&eacute;venez l'administrateur.</p></li>\n";
			else while ($row=@mysqli_fetch_row($r)) 
				printf("<li><p><a href=\"javascript:connect('id_circo',%d)\">%s</a></p></li>\n", $row[0],htmlentities($row[1],ENT_COMPAT,'ISO-8859-15'));
			print "</ul>\n";
		}
	}
	if (count($id_admins)>1) printf ("<p class=\"erreur\">ATTENTION! Vous possdez %d comptes administrateur ! Pr&eacute;venez l'administrateur.</p>",count($id_admins));
	if (count($id_stagiaires)+count($id_admins)+count($id_intervenants)==0) {
		print "<p>Aucune connexion ne vous a &eacute;t&eacute; attribu&eacute;e. Pr&eacute;venez l'administrateur.</p>\n";
	}
	if ($nbComptesSupprimables>0 && count($id_stagiaires)>1) {
		print "<h1>Oprations spciales</h1>";
		print "<h2><a href=\"ins_comptes_supprime.php?url_ret=compte.php\">Supprimer des comptes \"enseignants\" inutiliss</a></h2>\n";
		print "<p>Peut-tre n'utilisez-vous pas certains accs \"enseignants\" qui vous ont t affects ? Ce peut tre le cas si vous avez chang d'affectation, ou si vous tes remplaant... Utilisez cette fonctionnalit pour supprimer les comptes inutiliss.</p>\n";
	}
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-15" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
	   <script type="text/javascript" src="envoiemail.js"></script> 
		<script type="text/javascript">
		<!--
		function connect(ident, val)
		{
			document.form1.id.value=ident;
			document.form1.valeur.value=val;
			document.form1.submit();
		}			
		//-->	
		</script></head>
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="#bas">bas</a></li>
				</ul>
			</div>
		  <div id="corps" class="fond">	 
				<?php if ($erreur) print "<p class=\"erreur\">$erreur</p>";?> 
				<h1>Actualits</h1>
				<?php 
				if ($actu=='') print "<p>Le site est oprationnel.</p>\n"; 
				else afficheActualite($actu,true); 
				?>				
				<h1>Votre connexion &agrave; Circon'script </h1>
				<?php if ($use_sso && $sso_login) :?>
				<h4>Votre identifiant de connexion au portail<?php print empty($sso_portail)?" : $sso_login":" $sso_portail : $sso_login"?></h4>
				<?php endif;?> 
				<?php if ($use_sso && !$sso_bloque_exterieur) :?>
				<h4>Votre identifiant de connexion dans Circon'script pour une connexion directe hors portail : <?php print $login ?></h4>
				<?php elseif (!$use_sso) :?>
				<h4>Votre identifiant de connexion dans Circon'script : <?php print $login ?></h4>
				<?php  endif;?>
				<?php if (isset($_SESSION['circonscript7_sso'])) :?>
				<p>Les oprations de changement d'identifiant et de mot de passe ne sont pas disponibles dans Circon'script lorsque vous tes connect(e) via le portail <?php print empty($sso_portail)?'.':"$sso_portail."?></p>
				<?php endif;?>				
				<?php 
				if ($dtConnexion) {
					$tableau=explode(' ',$dtConnexion);
					if (count($tableau)==2) {
						printf ("<h4>Votre derni&egrave;re connexion a eu lieu le %s &agrave; %s</h4>\n",dateSQLEnTexte($tableau[0]),horaireSqlEnHeure($tableau[1]));
					}					 
				}
				?>
				<?php if (!isset($_SESSION['circonscript7_sso'])):?> 
				<h3><a href="compte_login.php?url_ret=compte.php">Changer l'identifiant de connexion (login) </a> </h3>
				<?php endif;?>
				<?php if (!isset($_SESSION['circonscript7_sso'])):?>
				<h3><a href="compte_mdp.php?url_ret=compte.php">Changer le mot de passe </a></h3>
				<?php endif;?>
				  <?php
				if (count($id_admins)>0) {
					print "<h3><a href=\"adm_admin.php?url_ret=compte.php\">Param&egrave;tres du compte administrateur</a></h3>\n";
					print "<p>Modification de votre adresse de courriel, de votre nom et pr&eacute;nom.</p>\n";
					}	
				?>
				<h1>Vos acc&egrave;s dans Circon'script </h1>
				<p><em>Cliquez sur un des liens ci-dessous pour acc&eacute;der au compte correspondant</em><em>.</em></p>
				<form id="form1" name="form1" method="post" action="">
				  <?php afficheConnexions($h) ?>
			      <input name="id" type="hidden" id="id" />
				  <input name="valeur" type="hidden" id="valeur" value="0" />
				</form>
		  </div>
			<div class="menu_secondaire">
				<ul class="menu2">
					<li><a href="#haut">haut</a></li>
				</ul>
			</div>
			<a name="bas" id="bas"></a>	
		</div>
	</body>
</html>
