/*******************************
Circonscript JavaScript script
e-mail: thierry.gangloff@ac-strasbourg.fr
Routines de gestion du mot de passe
**********************************/

function testeMdp(mdp1,mdp2, taillemin, strict)
{
	if (mdp1== "" || mdp2 == "") {
			alert("Il faut renseigner les deux champs du mot de passe");
			return '';
		}
	if (mdp1!= mdp2) {
			alert("Les mots de passe sont diffrents");
			return '';
	}	
	var l=mdp1.length;
	if (l<taillemin){
			alert("Le mot de passe doit comprendre au moins "+taillemin+" caractres");
			return '';
	}
	if (l>16) {
			alert("Le mot de passe est trop long: maximum 16 caractres");
			return '';
	}
	if (mdp1.charAt(0)==' ') {
		alert("Le mot de passe ne devrait pas commencer par un espace.");	
		return '';
	}
	if (mdp1.charAt(l-1)==' ') {
		alert( "Le mot de passe ne devrait pas se terminer par un espace.");
		return '';
	}
	// teste la conformit du mot de passe pour plus de scurit
	if (strict) {
		majuscule=false;
		minuscule=false;
		chiffre=false;
		incorrect=false;
		for (i=0;i<l; ++i) {
			c=mdp1.charAt(i);
			if (c>='A' && c<='Z') majuscule=true;
			else if (c>='a' && c<='z') minuscule=true;
			else if (c>='0' && c<='9') chiffre=true;
			else if (c!=' ' && c!='_' && c!='-') incorrect=true;
		}
		if (!chiffre || !majuscule || !minuscule || incorrect) {
				if (incorrect) {
						alert("Le mot de passe doit contenir uniquement des lettres non accentues, des chiffres, le trait d'union, le soulign et l'espace."); 
						return '';
				}
				msg='';
				if (!chiffre) msg="un chiffre";
				if (!majuscule) {
					if (msg) msg+=', ';
					msg+="une majuscule";
				}
				if (!minuscule){
					if (msg) msg+=', ';
					msg+="une minuscule";
				}
				msg+='.'; 
				alert("Le mot de passe est incorrect: il manque " + msg);
				return '';
			} 
	}
	else {
		incorrect=false;
		for (i=0;incorrect==false && i<l; ++i) {
			c=mdp1.charAt(i);
			incorrect= !((c>='A' && c<='Z') || (c>='a' && c<='z') || (c>='0' && c<='9') || c==' ' || c=='-' || c=='_');
		}
		if (incorrect) {
				alert("Le mot de passe doit contenir uniquement des lettres non accentues, des chiffres, le trait d'union, le soulign et l'espace."); 
				return '';
		}
	}
	return mdp1;
}
function encodeMdp(semence, mdp)
{
	i=0;
	j=0;
	L=mdp.length;
	ls=semence.length;
	
	if (L==0) {
			alert("Il faut indiquer un mot de passe");
			return '';
	}
	if (ls<2) {
			alert("Impossible de coder le mot de passe.");
			return '';
	} 
	if (ls%2) semence+='0';
	out='';
	for (i=0;i<L;++i) {
		c1=semence.charCodeAt(j);
		c2=semence.charCodeAt(j+1);	
		if (c1>=65) c1-=55;
		else c1-=48;
		if (c2>=65) c2-=55;
		else c2-=48;
		c=c1*16+c2;
		o=mdp.charCodeAt(i)^c;
		o1=o&0x0F;
		if (o1>=10) o1+=55;
		else o1+=48;
		o2=o>>4;
		if (o2>=10) o2+=55;
		else o2+=48;
		out+= String.fromCharCode(o2,o1);
		j+=2;
		if (j>=ls) j=0;
	}
	while (i<16) {
		out+=semence.substr(j,2);
		j+=2;
		if (j>=ls) j=0;
		++i;
	}
	return out;
	
}	
function testeMdpSimple(mdp)
{
		if (mdp=="") {
			alert("Veuillez taper un mot de passe");
			return false;
		}
	var l=mdp.length;
	if (l>16) {
			alert("Le mot de passe est trop long !");
			return false;
	}
	if (mdp.charAt(0)==' ') {
		alert("Le mot de passe ne doit pas commencer par un espace.");	
		return false;
	}
	if (mdp.charAt(l-1)==' ') {
		alert( "Le mot de passe ne doit pas se terminer par un espace.");
		return false;
	}

	// teste la conformit du mot de passe
	var i;
	for (i=0;i<l; ++i) {
		c=mdp.charAt(i);
		if ( ! ((c>='A' && c<='Z') || (c>='a' && c<='z') || (c>='0' && c<='9') ||  c==' ' || c=='_' || c=='-')) {
			alert("Le mot de passe ne doit pas contenir de caractres spciaux - part le soulign (sous le 8) et le trait d'union (sous le 6)- ni de lettres accentues.");
			return false;
		}
	}
	return true;	
}
